/*
Copyright 2002-2005 The Members of the OSS through Java(TM) Initiative.
All rights reserved. Use is subject to license terms.
*/
package javax.oss;


/**
 * Similar to java.lang.UnsupportedOperationException,
 * except this inherits from Exception, not RuntimeException.
 * This new class is required because J2EE containers deal with
 * RuntimeException in a special way.  See EJB specification.
 * <p>
 * This exception is thrown if a remote method is not implemented
 * (and the throws clause states that this exception may be thrown).
 * <p>
 * Note: This exception replaces the deprecated javax.oss.UnsupportedOperationException
 * 
 * @author OSS through Java Initiative, Vincent Perrot Sun Microsystems Inc.
 * @version 1.2
 * @since August 2005
 * @ossj:exception
 */
//AB decision 2005-08-12: Use OSS prefix for all OSSJ exception and respect the Exception inheritence
public class OssUnsupportedOperationException extends Exception {
//public class OssUnsupportedOperationException extends UnsupportedOperationException {
    /**
      * Constructs an OssUnsupportedOperationException with no detail message.
     */
    public OssUnsupportedOperationException() {
        super();
    }

    /**
      * Constructs an OssUnsupportedOperationException with the specified detail message.
     *
     * @param message the description of the problem.
     */
    public OssUnsupportedOperationException(String message) {
        super(message);
    }
}
