/**
 *	Generated with Tigerstripe(tm) v1.0.6
 *
 *  Tigerstripe(tm) is a registered trademark of Tigerstripe, Inc.
 *
 *	Plugin  : ts/ossj-jvt-spec (1.3)
 *	
 *  DO NOT EDIT THIS CODE WAS AUTOMATICALLY GENERATED
 *
 *  Generated from source Tigerstipe Artifact : javax.oss.cbe.AssociationRule
 */

/*
Copyright 2002-2006 The Members of the OSS through Java(TM) Initiative.
All rights reserved. Use is subject to license terms.
*/
package javax.oss.cbe;
   /**
    *	Public interface definition for AssociationRule
    *
    *  An association rule defines the constraints for the corresponding association type. 
    *  An association rule should be provided for every concrete association type. 
    *  <p> 
    *  
    *  <p> 
    *  Association Rules define: 
    *  <ul> 
    *  <li>the roles at each association end 
    *  <li>the cardinality of the association at each association end 
    *  <li>the type of entities or specifications involved at each association end 
    *  <li>the constraints applicable to this association 
    *  </ul> 
    *  <p> 
    *  If the constraints defined in an association rule are not respected during an 
    *  update operation (e.g. a creation of an association or a set operation on an 
    *  entity involved in the association) an <CODE>AssociationRuleViolationException</CODE> 
    *  is thrown.
    *
    *  @author: OSS through Java Initiative , Vincent Perrot Sun Microsystems Inc.
    *  @version: 1.3
    *  @since: March 2005
    *  @see: AssociationValue
    *
    *
    *
    */
public interface AssociationRule
	extends java.lang.Cloneable, java.io.Serializable
{



    /**
     * Deep copy of this object
     */
    public Object clone();

	
   /**
    * 
    * Attribute getter for associationType
    *
    *** Automatically created by Tigerstripe workbench from user defined attribute: AssociationRule.associationType ***
    *
    *
    * 
    * @return the value of the associationType field.
    *     * 
    */
        public java.lang.String getAssociationType()
         ;

   /**
    * Attribute setter for associationType
    * 
    *  Set the association type.
    * @param value - the value to use to set the associationType attribute.
    * @throws java.lang.IllegalArgumentException - Is thrown to report that a bad argument was provided to the method.
    *     *    
    */
	public void setAssociationType( java.lang.String value )
		throws java.lang.IllegalArgumentException;
   /**
    * 
    * Attribute getter for AEndRole
    *
    *** Automatically created by Tigerstripe workbench from user defined attribute: AssociationRule.AEndRole ***
    *
    *
    * 
    * @return the value of the AEndRole field.
    *     * 
    */
        public java.lang.String getAEndRole()
         ;

   /**
    * Attribute setter for AEndRole
    * 
    *  Set the A end role. 
    *  For example, if an association value representing an 
    *  aggregation association has an attribute "<CODE>Aggregating</CODE>" with the corresponding 
    *  accessors "<CODE>getAggregating</CODE>" and "<CODE>setAggregating</CODE>", the association rule for 
    *  this association type has one of the roles defined as "<CODE>Aggregating</CODE>".
    * @param value - the value to use to set the AEndRole attribute.
    * @throws java.lang.IllegalArgumentException - Is thrown to report that a bad argument was provided to the method.
    *     *    
    */
	public void setAEndRole( java.lang.String value )
		throws java.lang.IllegalArgumentException;
   /**
    * 
    * Attribute getter for ZEndRole
    *
    *** Automatically created by Tigerstripe workbench from user defined attribute: AssociationRule.ZEndRole ***
    *
    *
    * 
    * @return the value of the ZEndRole field.
    *     * 
    */
        public java.lang.String getZEndRole()
         ;

   /**
    * Attribute setter for ZEndRole
    * 
    *  Set the Z end role. 
    *  For example, if an association value representing an 
    *  aggregation association has an attribute "<CODE>Aggregating</CODE>" with the corresponding 
    *  accessors ("<CODE>getAggregating</CODE>" and "<CODE>setAggregating</CODE>") the association rule for 
    *  this association type has one of the roles defined as "<CODE>Aggregating</CODE>".
    * @param value - the value to use to set the ZEndRole attribute.
    * @throws java.lang.IllegalArgumentException - Is thrown to report that a bad argument was provided to the method.
    *     *    
    */
	public void setZEndRole( java.lang.String value )
		throws java.lang.IllegalArgumentException;
   /**
    * 
    * Attribute getter for AEndCardinality
    *
    *** Automatically created by Tigerstripe workbench from user defined attribute: AssociationRule.AEndCardinality ***
    *
    *
    * 
    * @return the value of the AEndCardinality field.
    *     * 
    */
        public javax.oss.cbe.Cardinality getAEndCardinality()
         ;
   /**
    * 
    * Attribute Type getter for AEndCardinality
    *
    * @return the valid set of types for the AEndCardinality field.
    * 
    */
       public String[] attributeTypeForAEndCardinality();

   /**
    * Attribute setter for AEndCardinality
    * 
    *  Set the A end cardinality.
    * @param value - the value to use to set the AEndCardinality attribute.
    * @throws java.lang.IllegalArgumentException - Is thrown to report that a bad argument was provided to the method.
    *     *    
    */
	public void setAEndCardinality( javax.oss.cbe.Cardinality value )
		throws java.lang.IllegalArgumentException;
   /**
    * 
    * Attribute getter for ZEndCardinality
    *
    *** Automatically created by Tigerstripe workbench from user defined attribute: AssociationRule.ZEndCardinality ***
    *
    *
    * 
    * @return the value of the ZEndCardinality field.
    *     * 
    */
        public javax.oss.cbe.Cardinality getZEndCardinality()
         ;
   /**
    * 
    * Attribute Type getter for ZEndCardinality
    *
    * @return the valid set of types for the ZEndCardinality field.
    * 
    */
       public String[] attributeTypeForZEndCardinality();

   /**
    * Attribute setter for ZEndCardinality
    * 
    *  Set the Z end cardinality.
    * @param value - the value to use to set the ZEndCardinality attribute.
    * @throws java.lang.IllegalArgumentException - Is thrown to report that a bad argument was provided to the method.
    *     *    
    */
	public void setZEndCardinality( javax.oss.cbe.Cardinality value )
		throws java.lang.IllegalArgumentException;
   /**
    * 
    * Attribute getter for AEndType
    *
    *** Automatically created by Tigerstripe workbench from user defined attribute: AssociationRule.AEndType ***
    *
    *
    * 
    * @return the value of the AEndType field.
    *     * 
    */
        public java.lang.String getAEndType()
         ;

   /**
    * Attribute setter for AEndType
    * 
    *  Set the entity or specification type for the A end.
    * @param value - the value to use to set the AEndType attribute.
    * @throws java.lang.IllegalArgumentException - Is thrown to report that a bad argument was provided to the method.
    *     *    
    */
	public void setAEndType( java.lang.String value )
		throws java.lang.IllegalArgumentException;
   /**
    * 
    * Attribute getter for ZEndType
    *
    *** Automatically created by Tigerstripe workbench from user defined attribute: AssociationRule.ZEndType ***
    *
    *
    * 
    * @return the value of the ZEndType field.
    *     * 
    */
        public java.lang.String getZEndType()
         ;

   /**
    * Attribute setter for ZEndType
    * 
    *  Set the entity or specification type for the Z end.
    * @param value - the value to use to set the ZEndType attribute.
    * @throws java.lang.IllegalArgumentException - Is thrown to report that a bad argument was provided to the method.
    *     *    
    */
	public void setZEndType( java.lang.String value )
		throws java.lang.IllegalArgumentException;


    /**
    * Factory method for Cardinality
    * 
    * @return a new instance of Cardinality
    */
    public javax.oss.cbe.Cardinality makeCardinality(String typeToMake)
    	 throws java.lang.IllegalArgumentException;


}
