/**
 *	Generated with Tigerstripe(tm) v1.0.6
 *
 *  Tigerstripe(tm) is a registered trademark of Tigerstripe, Inc.
 *
 *	Plugin  : ts/ossj-jvt-spec (1.3)
 *	
 *  DO NOT EDIT THIS CODE WAS AUTOMATICALLY GENERATED
 *
 *  Generated from source Tigerstipe Artifact : javax.oss.cbe.Cardinality
 */

/*
Copyright 2002-2006 The Members of the OSS through Java(TM) Initiative.
All rights reserved. Use is subject to license terms.
*/
package javax.oss.cbe;
   /**
    *	Public interface definition for Cardinality
    *
    *  The <CODE>Cardinality</CODE> defines the numeric relationships between occurrences of the 
    *  entities on either end of a relationship. 
    *  This interface defines the cardinality value of the association's end. 
    *  The <CODE>Cardinality</CODE> interface is used in {@link AssociationRule AssociationRules}. 
    *  An association rule defines the constraints for a particular association type 
    *  and the cardinality is one of the constraints defined in the rule. 
    *  The cardinality is accessed through the {@link AssociationRule#getAEndCardinality getAEndCardinality()} 
    *  and {@link AssociationRule#getZEndCardinality getZEndCardinality()} 
    *  methods of the {@link AssociationRule AssociationRule} interface.
    *
    *  @author: OSS through Java Initiative, Vincent Perrot Sun Microsystems Inc.
    *  @version: 1.3
    *  @since: March 2005
    *  @see: AssociationRule
    *
    *
    *
    */
public interface Cardinality
	extends java.lang.Cloneable, java.io.Serializable
{

	public final static int MAX_CARDINALITY = Integer.MAX_VALUE;


    /**
     * Deep copy of this object
     */
    public Object clone();

	
   /**
    * 
    * Attribute getter for minNumber
    *
    *** Automatically created by Tigerstripe workbench from user defined attribute: Cardinality.minNumber ***
    *
    *
    * 
    * @return the value of the minNumber field.
    *     * 
    */
        public int getMinNumber()
         ;

   /**
    * Attribute setter for minNumber
    * 
    *  Sets the number defining the minimum of the cardinality value at 
    *  the association's end.
    * @param value - the value to use to set the minNumber attribute.
    * @throws java.lang.IllegalArgumentException - Is thrown to report that a bad argument was provided to the method.
    *     *    
    */
	public void setMinNumber( int value )
		throws java.lang.IllegalArgumentException;
   /**
    * 
    * Attribute getter for maxNumber
    *
    *** Automatically created by Tigerstripe workbench from user defined attribute: Cardinality.maxNumber ***
    *
    *
    * 
    * @return the value of the maxNumber field.
    *     * 
    */
        public int getMaxNumber()
         ;

   /**
    * Attribute setter for maxNumber
    * 
    *  Sets the number defining the maximum of the cardinality value at 
    *  the association's end. The maximum is either a non negative integer 
    *  or has a value of "<CODE>MAX_CARDINALITY</CODE>" to indicate "n" or "many" 
    *  for example in a "0..n", "1..n" type cardinality value(see {@link #MAX_CARDINALITY}).
    * @param value - the value to use to set the maxNumber attribute.
    * @throws java.lang.IllegalArgumentException - Is thrown to report that a bad argument was provided to the method.
    *     *    
    */
	public void setMaxNumber( int value )
		throws java.lang.IllegalArgumentException;


}
