/**
 *	Generated with Tigerstripe(tm) v1.0.6
 *
 *  Tigerstripe(tm) is a registered trademark of Tigerstripe, Inc.
 *
 *	Plugin  : ts/ossj-jvt-spec (1.3)
 *	
 *  DO NOT EDIT THIS CODE WAS AUTOMATICALLY GENERATED
 *
 *  Generated from source Tigerstipe Artifact : javax.oss.cbe.EntitySpecification
 */

/*
Copyright 2002-2006 The Members of the OSS through Java(TM) Initiative.
All rights reserved. Use is subject to license terms.
*/
package javax.oss.cbe;
   /**
    *	Public interface definition for EntitySpecification
    *
    *  <CODE>EntitySpecificationValue</CODE> is the base for all specification entities. 
    *  <p> 
    *  An entity specification captures characteristics and constraints 
    *  applicable to instances of the same entity type. For example a 
    *  "<CODE>GoldBroadbandAccessServicespecification</CODE>" will capture the characteristics, 
    *  configuration and QoS parameter ranges, specific to a "<CODE>Gold</CODE>" Broadband 
    *  Access service offering. Several specification instances may exist for the same 
    *  entity type. "<CODE>Gold</CODE>", "<CODE>Silver</CODE>" and "<CODE>Bronze</CODE>" specifications may be defined 
    *  for a "<CODE>BroadbandAccessService</CODE>". 
    *  <p> 
    *  Catalogues are collections of entity specifications (e.g. service catalogue composed 
    *  of service specifications, product catalogue composed of product specifications, resource 
    *  catalogue composed of resource specifications). 
    *  <p> 
    *  An entity instance is defined by a single entity specification. 
    *  The same entity specification may be used to define multiple entity instances. 
    *  An association exists between the entity specification and the entity instances, 
    *  defined by this specification (the values of the <CODE>describingSpecification</CODE> 
    *  attributes of the entities are set with the key of the specification). 
    *  The specification defines default values for all attributes of the corresponding entity type. 
    *  <p> 
    *  Entity specifications provide a factory method for the attribute constraints they contain. 
    *  Note that the CBE package does not specify through how attribute constraints are defined. 
    *  Specific implementations of the CBE interfaces should define the 
    *  concrete attribute constraint interfaces and the methods on the entity specification 
    *  that allow to get and set these constraints. 
    *  <p> 
    *  Entity specifications are represented as managed entities 
    *  (according to the OSS through Java definition of managed entity). 
    *  <CODE>EntitySpecification</CODE> instances have their own key and can be retrieved through 
    *  API specific <CODE>JVTSession</CODE> interfaces. 
    *  The following example show how to use the Inventory API to update a <CODE>ProductSpecification</CODE>: 
    *  <pre> 
    *  <CODE> 
    *  JVTInventorySession jvt = ...; 
    *  EntitySpecificationKey key = ...; 
    *  ProductSpecificationValue value = (ProductSpecificationValue)jvt.getEntitySpecificationByKey(key); 
    *  value.setAttributeValue("..."); 
    *  jvt.setEntitySpecificationByValue(value); 
    *  </CODE> 
    *  </pre> 
    *  <p> 
    *  The specification for a given entity type may be used as a factory for 
    *  value objects or for creating entity instances of this entity type. 
    *  For example using the Inventory API: 
    *  <pre> 
    *  <CODE>JVT<...>InventorySession.make<...>EntityValueFromSpecification()</CODE> and the 
    *  <CODE>JVT<...>InventorySession.create<...>EntityFromSpecification()</CODE> methods. 
    *  </pre> 
    *  <p> 
    *  Entity specifications are uniquely identified by their keys. 
    *  See {@link EntitySpecificationKey} for more information. 
    *  <p> 
    *  <CODE>EntitySpecificationValue</CODE> inherits from <CODE>ManagedEntityValue</CODE> all methods 
    *  for population, generic attribute access and serialization.
    *
    *  @author: OSS through Java Initiative , Vincent Perrot Sun Microsystems Inc.
    *  @version: 1.3
    *  @since: March 2005
    *  @see: CBEManagedEntityValue
    *  @see: EntitySpecificationKey
    *
    *
    *
    */
public interface EntitySpecificationValue
	extends javax.oss.cbe.CBEManagedEntityValue
{
	public static final String VALUE_TYPE = "javax.oss.cbe.EntitySpecificationValue";
	public static final String ENTITY_SPECIFICATION_KEY = "entitySpecificationKey";


     public final static String DESCRIBED_ENTITY_TYPE = "describedEntityType";

	/**
     * Deep copy of this object
     */
    public Object clone();
   /**
    * 
    * Attribute getter for describedEntityType
    *
    *** Automatically created by Tigerstripe workbench from user defined attribute: EntitySpecification.describedEntityType ***
    *
    *
    * 
    * @return the value of the describedEntityType field.
    * @throws java.lang.IllegalStateException - if the attribute is not populated.
    *     * 
    */
        public java.lang.String getDescribedEntityType()
            throws
 	        java.lang.IllegalStateException
         ;

   /**
    * Attribute setter for describedEntityType
    * 
    *  Set the entity type to which this specification applies.
    * @param value - the value to use to set the describedEntityType attribute.
    * @throws java.lang.IllegalArgumentException - Is thrown to report that a bad argument was provided to the method.
    *     *    
    */
	public void setDescribedEntityType( java.lang.String value )
		throws java.lang.IllegalArgumentException;


    /**
     * Gets the key for this value object
     *
     * @return the key for this value object
     * @throws java.lang.IllegalStateException if no key was populated in this
     *    value object.
     */
	public javax.oss.cbe.EntitySpecificationKey getEntitySpecificationKey()
	    throws java.lang.IllegalStateException;
	
	/**
	 * Sets the key for this value object
	 *
	 * @param key - the key to set on this value object.
	 * @throws java.lang.IllegalArgumentException, if the key is not a valid
	 *    key for this value object.
	 */
	public void setEntitySpecificationKey( javax.oss.cbe.EntitySpecificationKey key )
		throws java.lang.IllegalArgumentException;
	
    /**
     * Factory method for EntitySpecificationKey
     *
     * @return a new instance of a blank EntitySpecificationKey
     */
	public javax.oss.cbe.EntitySpecificationKey makeEntitySpecificationKey();
	

}
