/**
 *	Generated with Tigerstripe(tm) v1.0.6
 *
 *  Tigerstripe(tm) is a registered trademark of Tigerstripe, Inc.
 *
 *	Plugin  : ts/ossj-jvt-spec (1.3)
 *	
 *  DO NOT EDIT THIS CODE WAS AUTOMATICALLY GENERATED
 *
 *  Generated from source Tigerstipe Artifact : javax.oss.cbe.measurement.PerformanceAttributeDescriptor
 */

/*
Copyright 2002-2006 The Members of the OSS through Java(TM) Initiative.
All rights reserved. Use is subject to license terms.
*/
package javax.oss.cbe.measurement;
   /**
    *	Public interface definition for PerformanceAttributeDescriptor
    *
    *  Represent a measurement attribute that can be monitored in the observable object class. 
    *  
    *  <p> 
    *  The measurement attribute name is short form of the measurement name and it is used to 
    *  identify the measurement attribute in the measurement result reports. 
    *  
    *  <p> 
    *  The type of the measurement can be: 
    *  <ul> 
    *  <li>Integer 
    *  <li>Real 
    *  <li>String 
    *  </ul> 
    *  
    *  <p> 
    *  Each measurement job will be collecting result data at a particular frequency, 
    *  known as the granularity period of the measurement. At the end of the granularity period 
    *  a scheduled result report shall be generated for each measurement job that is actively 
    *  collecting performance measurement data. The measurement data can be collected in a number of ways: 
    *  <ul> 
    *  <li>cumulative incremental counters triggered by the occurrence of the measured event; 
    *  <li>status inspection (i.e. a mechanism for high frequency sampling of internal counters at pre-defined rates); 
    *  <li>gauges (i.e. high tide mark, low tide mark); 
    *  <li>discrete event registration, where data related to a particular event is captured. 
    *  </ul>
    *
    *  @author: OSS through Java Initiative, Vincent Perrot Sun Microsystems Inc.
    *  @version: 1.3
    *  @since: March 2005
    *
    *
    *
    *
    */
public interface PerformanceAttributeDescriptor
	extends java.lang.Cloneable, java.io.Serializable
{

	public final static int INTEGER = 1;
	public final static int REAL = 2;
	public final static int STRING = 3;
	public final static java.lang.String CUMULATIVE_COUNTER = "CC";
	public final static java.lang.String GAUGE = "GAUGE";
	public final static java.lang.String DISCRETE_EVENT_REGISTRATION = "DER";
	public final static java.lang.String STATUS_INSPECTION = "SI";


    /**
     * Deep copy of this object
     */
    public Object clone();

	
   /**
    * 
    * Attribute getter for name
    *
    *** Automatically created by Tigerstripe workbench from user defined attribute: PerformanceAttributeDescriptor.name ***
    *
    *
    * 
    * @return the value of the name field.
    *     * 
    */
        public java.lang.String getName()
         ;

   /**
    * Attribute setter for name
    * 
    *  Sets the performance attribute name.
    * @param value - the value to use to set the name attribute.
    * @throws java.lang.IllegalArgumentException - Is thrown to report that a bad argument was provided to the method.
    *     *    
    */
	public void setName( java.lang.String value )
		throws java.lang.IllegalArgumentException;
   /**
    * 
    * Attribute getter for type
    *
    *** Automatically created by Tigerstripe workbench from user defined attribute: PerformanceAttributeDescriptor.type ***
    *
    *
    * 
    * @return the value of the type field.
    *     * 
    */
        public int getType()
         ;

   /**
    * Attribute setter for type
    * 
    *  Sets the type of attribute. 
    *  
    *  <p> 
    *  Valid values are: 
    *  <ul> 
    *  <li> <CODE>PerformanceAttributeDescriptor.INTEGER</CODE> 
    *  <li> <CODE>PerformanceAttributeDescriptor.REAL</CODE> 
    *  <li> <CODE>PerformanceAttributeDescriptor.STRING</CODE> 
    *  </ul>
    * @param value - the value to use to set the type attribute.
    * @throws java.lang.IllegalArgumentException - Is thrown to report that a bad argument was provided to the method.
    *     *    
    */
	public void setType( int value )
		throws java.lang.IllegalArgumentException;
   /**
    * 
    * Attribute getter for collectionMethod
    *
    *** Automatically created by Tigerstripe workbench from user defined attribute: PerformanceAttributeDescriptor.collectionMethod ***
    *
    *
    * 
    * @return the value of the collectionMethod field.
    *     * 
    */
        public java.lang.String getCollectionMethod()
         ;

   /**
    * Attribute setter for collectionMethod
    * 
    *  Sets the collection method. 
    *  
    *  <p> 
    *  Valid values are: 
    *  <ul> 
    *  <li> <CODE>PerformanceAttributeDescriptor.CUMULATIVE_COUNTER</CODE> 
    *  <li> <CODE>PerformanceAttributeDescriptor.GAUGE</CODE> 
    *  <li> <CODE>PerformanceAttributeDescriptor.DISCRETE_EVENT_REGISTRATION</CODE> 
    *  <li> <CODE>PerformanceAttributeDescriptor.STATUS_INSPECTION</CODE> 
    *  </ul>
    * @param value - the value to use to set the collectionMethod attribute.
    * @throws java.lang.IllegalArgumentException - Is thrown to report that a bad argument was provided to the method.
    *     *    
    */
	public void setCollectionMethod( java.lang.String value )
		throws java.lang.IllegalArgumentException;
   /**
    * 
    * Attribute getter for array
    *
    *** Automatically created by Tigerstripe workbench from user defined attribute: PerformanceAttributeDescriptor.array ***
    *
    *
    * 
    * @return the value of the array field.
    *     * 
    */
        public boolean isArray()
         ;

   /**
    * Attribute setter for array
    * 
    *  Sets if the attribute is an array.
    * @param value - the value to use to set the array attribute.
    * @throws java.lang.IllegalArgumentException - Is thrown to report that a bad argument was provided to the method.
    *     *    
    */
	public void setArray( boolean value )
		throws java.lang.IllegalArgumentException;


}
