/**
 *	Generated with Tigerstripe(tm) v1.0.6
 *
 *  Tigerstripe(tm) is a registered trademark of Tigerstripe, Inc.
 *
 *	Plugin  : ts/ossj-jvt-spec (1.3)
 *	
 *  DO NOT EDIT THIS CODE WAS AUTOMATICALLY GENERATED
 *
 *  Generated from source Tigerstipe Artifact : javax.oss.cbe.measurement.PerformanceMonitorByClasses
 */

/*
Copyright 2002-2006 The Members of the OSS through Java(TM) Initiative.
All rights reserved. Use is subject to license terms.
*/
package javax.oss.cbe.measurement;
   /**
    *	Public interface definition for PerformanceMonitorByClasses
    *
    *  This interface is the value representation of a measurement job that monitor a set of 
    *  specified attributes on a set of observable object classes. 
    *  
    *  <p> 
    *  This interface extends the PerformanceMonitorValue interface with a new attribute: 
    *  <ul> 
    *  <li>a list of measurement attributes to monitor. 
    *  <li>a list of Observable Object classes. 
    *  <li>a scope that define from where to find the observable object classes. 
    *  </ul> 
    *  
    *  <p> 
    *  The new attributes, of the value object, are a list of observed object classes that 
    *  shall be monitored, with a scope, and an optional list of measurement attributes, that 
    *  identify what is monitored by the measurement job. 
    *  If the measurement attribute list is omitted, all measurement attributes in the observed 
    *  object instances will be monitored (scanned).
    *
    *  @author: OSS through Java Initiative, Vincent Perrot Sun Microsystems Inc.
    *  @version: 1.3
    *  @since: March 2005
    *
    *
    *
    *
    */
public interface PerformanceMonitorByClassesValue
	extends javax.oss.cbe.measurement.PerformanceMonitorValue
{
	public static final String VALUE_TYPE = "javax.oss.cbe.measurement.PerformanceMonitorByClassesValue";
	public static final String PERFORMANCE_MONITOR_BY_CLASSES_KEY = "performanceMonitorByClassesKey";


     public final static String MEASUREMENT_ATTRIBUTES = "measurementAttributes";
     public final static String OBSERVED_OBJECT_CLASSES = "observedObjectClasses";
     public final static String SCOPE = "scope";

	/**
     * Deep copy of this object
     */
    public Object clone();
   /**
    * 
    * Attribute getter for measurementAttributes
    *
    *** Automatically created by Tigerstripe workbench from user defined attribute: PerformanceMonitorByClasses.measurementAttributes ***
    *
    *
    * 
    * @return the value of the measurementAttributes field.
    * @throws java.lang.IllegalStateException - if the attribute is not populated.
    *     * 
    */
        public javax.oss.cbe.measurement.PerformanceAttributeDescriptor[] getMeasurementAttributes()
            throws
 	        java.lang.IllegalStateException
         ;
   /**
    * 
    * Attribute Type getter for measurementAttributes
    *
    * @return the valid set of types for the measurementAttributes field.
    * 
    */
       public String[] attributeTypeForMeasurementAttributes();

   /**
    * Attribute setter for measurementAttributes
    * 
    *  Sets the measurement attributes to be monitored. 
    *  
    *  <p> 
    *  The supplied measurement attribute must be supported of all monitored objects. 
    *  
    *  <p> 
    *  The measurement attributes will be validated when the value object is passed 
    *  to the performance monitor bean. 
    *  
    *  <p> 
    *  If the measurement attribute list shall be omitted, an empty list must be set.
    * @param value - the value to use to set the measurementAttributes attribute.
    * @throws java.lang.IllegalArgumentException - Is thrown to report that a bad argument was provided to the method.
    *     *    
    */
	public void setMeasurementAttributes( javax.oss.cbe.measurement.PerformanceAttributeDescriptor[] value )
		throws java.lang.IllegalArgumentException;
   /**
    * 
    * Attribute getter for observedObjectClasses
    *
    *** Automatically created by Tigerstripe workbench from user defined attribute: PerformanceMonitorByClasses.observedObjectClasses ***
    *
    *
    * 
    * @return the value of the observedObjectClasses field.
    * @throws java.lang.IllegalStateException - if the attribute is not populated.
    *     * 
    */
        public java.lang.String[] getObservedObjectClasses()
            throws
 	        java.lang.IllegalStateException
         ;

   /**
    * Attribute setter for observedObjectClasses
    * 
    *  Sets the observable object classes that shall be monitored. 
    *  
    *  <p> 
    *  The observable object classes will be validated when the value object is passed 
    *  to the performance monitor bean. 
    *  
    *  <p> 
    *  The supported observable classes can be retrieved by using the PerformanceMonitor.getObservableObjectClasses
    * @param value - the value to use to set the observedObjectClasses attribute.
    * @throws java.lang.IllegalArgumentException - Is thrown to report that a bad argument was provided to the method.
    *     *    
    */
	public void setObservedObjectClasses( java.lang.String[] value )
		throws java.lang.IllegalArgumentException;
   /**
    * 
    * Attribute getter for scope
    *
    *** Automatically created by Tigerstripe workbench from user defined attribute: PerformanceMonitorByClasses.scope ***
    *
    *
    * 
    * @return the value of the scope field.
    * @throws java.lang.IllegalStateException - if the attribute is not populated.
    *     * 
    */
        public java.lang.String getScope()
            throws
 	        java.lang.IllegalStateException
         ;

   /**
    * Attribute setter for scope
    * 
    *  Sets the distinguished name of the object where the scope shall start from.
    * @param value - the value to use to set the scope attribute.
    * @throws java.lang.IllegalArgumentException - Is thrown to report that a bad argument was provided to the method.
    *     *    
    */
	public void setScope( java.lang.String value )
		throws java.lang.IllegalArgumentException;


    /**
    * Factory method for PerformanceAttributeDescriptor
    * 
    * @return a new instance of PerformanceAttributeDescriptor
    */
    public javax.oss.cbe.measurement.PerformanceAttributeDescriptor[] makePerformanceAttributeDescriptors(int howMany , String typeToMake)
    	 throws java.lang.IllegalArgumentException;


    /**
     * Gets the key for this value object
     *
     * @return the key for this value object
     * @throws java.lang.IllegalStateException if no key was populated in this
     *    value object.
     */
	public javax.oss.cbe.measurement.PerformanceMonitorByClassesKey getPerformanceMonitorByClassesKey()
	    throws java.lang.IllegalStateException;
	
	/**
	 * Sets the key for this value object
	 *
	 * @param key - the key to set on this value object.
	 * @throws java.lang.IllegalArgumentException, if the key is not a valid
	 *    key for this value object.
	 */
	public void setPerformanceMonitorByClassesKey( javax.oss.cbe.measurement.PerformanceMonitorByClassesKey key )
		throws java.lang.IllegalArgumentException;
	
    /**
     * Factory method for PerformanceMonitorByClassesKey
     *
     * @return a new instance of a blank PerformanceMonitorByClassesKey
     */
	public javax.oss.cbe.measurement.PerformanceMonitorByClassesKey makePerformanceMonitorByClassesKey();
	

}
