/**
 *	Generated with Tigerstripe(tm) v1.0.6
 *
 *  Tigerstripe(tm) is a registered trademark of Tigerstripe, Inc.
 *
 *	Plugin  : ts/ossj-jvt-spec (1.3)
 *	
 *  DO NOT EDIT THIS CODE WAS AUTOMATICALLY GENERATED
 *
 *  Generated from source Tigerstipe Artifact : javax.oss.cbe.measurement.PerformanceMonitorByObjects
 */

/*
Copyright 2002-2006 The Members of the OSS through Java(TM) Initiative.
All rights reserved. Use is subject to license terms.
*/
package javax.oss.cbe.measurement;
   /**
    *	Public interface definition for PerformanceMonitorByObjects
    *
    *  This interface is the value representation of a measurement job that monitor a set of 
    *  specified attributes on a set of observable object instances. 
    *  
    *  <p> 
    *  This interface extends the PerformanceMonitorValue interface with a new attribute: 
    *  <ul> 
    *  <li>a list of measurement attributes to monitor. 
    *  <li>a list of observable object instances. 
    *  </ul> 
    *  
    *  <p> 
    *  The new attributes, of the value object, are a list of observed object instances that 
    *  shall be monitored and an optional list of measurement attributes, that identify what 
    *  is monitored by the measurement job. 
    *  If the measurement attribute list is omitted, all measurement attributes in the observed 
    *  object instances will be monitored (scanned). The observable object instances should be of the 
    *  same type.
    *
    *  @author: OSS through Java Initiative, Vincent Perrot Sun Microsystems Inc.
    *  @version: 1.3
    *  @since: March 2005
    *
    *
    *
    *
    */
public interface PerformanceMonitorByObjectsValue
	extends javax.oss.cbe.measurement.PerformanceMonitorValue
{
	public static final String VALUE_TYPE = "javax.oss.cbe.measurement.PerformanceMonitorByObjectsValue";
	public static final String PERFORMANCE_MONITOR_BY_OBJECTS_KEY = "performanceMonitorByObjectsKey";


     public final static String MEASUREMENT_ATTRIBUTES = "measurementAttributes";
     public final static String OBSERVED_OBJECTS = "observedObjects";

	/**
     * Deep copy of this object
     */
    public Object clone();
   /**
    * 
    * Attribute getter for measurementAttributes
    *
    *** Automatically created by Tigerstripe workbench from user defined attribute: PerformanceMonitorByObjects.measurementAttributes ***
    *
    *
    * 
    * @return the value of the measurementAttributes field.
    * @throws java.lang.IllegalStateException - if the attribute is not populated.
    *     * 
    */
        public javax.oss.cbe.measurement.PerformanceAttributeDescriptor[] getMeasurementAttributes()
            throws
 	        java.lang.IllegalStateException
         ;
   /**
    * 
    * Attribute Type getter for measurementAttributes
    *
    * @return the valid set of types for the measurementAttributes field.
    * 
    */
       public String[] attributeTypeForMeasurementAttributes();

   /**
    * Attribute setter for measurementAttributes
    * 
    *  Sets the measurement attributes to be monitored. 
    *  
    *  <p> 
    *  The supplied measurement attribute must be supported of all monitored objects. 
    *  
    *  <p> 
    *  The measurement attributes will be validated when the value object is passed 
    *  to the performance monitor bean. 
    *  
    *  <p> 
    *  If the measurement attribute list shall be omitted, an empty list must be set.
    * @param value - the value to use to set the measurementAttributes attribute.
    * @throws java.lang.IllegalArgumentException - Is thrown to report that a bad argument was provided to the method.
    *     *    
    */
	public void setMeasurementAttributes( javax.oss.cbe.measurement.PerformanceAttributeDescriptor[] value )
		throws java.lang.IllegalArgumentException;
   /**
    * 
    * Attribute getter for observedObjects
    *
    *** Automatically created by Tigerstripe workbench from user defined attribute: PerformanceMonitorByObjects.observedObjects ***
    *
    *
    * 
    * @return the value of the observedObjects field.
    * @throws java.lang.IllegalStateException - if the attribute is not populated.
    *     * 
    */
        public java.lang.String[] getObservedObjects()
            throws
 	        java.lang.IllegalStateException
         ;

   /**
    * Attribute setter for observedObjects
    * 
    *  Sets the observable object that shall be monitored. 
    *  
    *  <p> 
    *  The observable objects will be validated when the value object is passed 
    *  to the performance monitor bean. 
    *  
    *  <p> 
    *  The supported observable objects can be retrieved by using the PerformanceMonitor.getObservableObjects
    * @param value - the value to use to set the observedObjects attribute.
    * @throws java.lang.IllegalArgumentException - Is thrown to report that a bad argument was provided to the method.
    *     *    
    */
	public void setObservedObjects( java.lang.String[] value )
		throws java.lang.IllegalArgumentException;


    /**
    * Factory method for PerformanceAttributeDescriptor
    * 
    * @return a new instance of PerformanceAttributeDescriptor
    */
    public javax.oss.cbe.measurement.PerformanceAttributeDescriptor[] makePerformanceAttributeDescriptors(int howMany , String typeToMake)
    	 throws java.lang.IllegalArgumentException;


    /**
     * Gets the key for this value object
     *
     * @return the key for this value object
     * @throws java.lang.IllegalStateException if no key was populated in this
     *    value object.
     */
	public javax.oss.cbe.measurement.PerformanceMonitorByObjectsKey getPerformanceMonitorByObjectsKey()
	    throws java.lang.IllegalStateException;
	
	/**
	 * Sets the key for this value object
	 *
	 * @param key - the key to set on this value object.
	 * @throws java.lang.IllegalArgumentException, if the key is not a valid
	 *    key for this value object.
	 */
	public void setPerformanceMonitorByObjectsKey( javax.oss.cbe.measurement.PerformanceMonitorByObjectsKey key )
		throws java.lang.IllegalArgumentException;
	
    /**
     * Factory method for PerformanceMonitorByObjectsKey
     *
     * @return a new instance of a blank PerformanceMonitorByObjectsKey
     */
	public javax.oss.cbe.measurement.PerformanceMonitorByObjectsKey makePerformanceMonitorByObjectsKey();
	

}
