/**
 *	Generated with Tigerstripe(tm) v1.0.6
 *
 *  Tigerstripe(tm) is a registered trademark of Tigerstripe, Inc.
 *
 *	Plugin  : ts/ossj-jvt-spec (1.3)
 *	
 *  DO NOT EDIT THIS CODE WAS AUTOMATICALLY GENERATED
 *
 *  Generated from source Tigerstipe Artifact : javax.oss.cbe.measurement.PerformanceMonitor
 */

/*
Copyright 2002-2006 The Members of the OSS through Java(TM) Initiative.
All rights reserved. Use is subject to license terms.
*/
package javax.oss.cbe.measurement;
   /**
    *	Public interface definition for PerformanceMonitor
    *
    *  This interface is the base value representation of a measurement job. 
    *  
    *  <p> 
    *  The <CODE>JVTPerformanceMonitorSession</CODE> manages measurement jobs. A client can create and retrieve 
    *  measurement jobs indirectly by using the methods of an <CODE>JVTPerformanceMonitorSession</CODE>. 
    *  
    *  <p><ul> 
    *  A measurement job shall include: 
    *  <li>a granularity specifying the rate at which performance data is read (scanned). 
    *  <li>a reporting mode indicating the manner in which clients are notified of the generation 
    *  of a measurement results. 
    *  <li>a report format indicating the format of the result reports to be generated. 
    *  <li>a schedule specifying the schedule of the monitoring activity. 
    *  <li>a key that identify the measurement job. 
    *  <li>a state of the measurement job. 
    *  </ul> 
    *  
    *  <p> 
    *  The granularity period is the time between the initiation of two successive gatherings 
    *  of measurement data within the timeframe specified in the scheduling attributes. 
    *  
    *  <p> 
    *  The reporting mode is used to specify the reporting method of the measurement result 
    *  reports of the measurement job. 
    *  The reporting mode can be either file or event or both. If the reporting mode is 
    *  set to event the system will emit an event that carries the measurement result reports. 
    *  If the reporting mode is set to file, the measurement job will capture the measurement 
    *  result reports into a data storage and then emit an event to the client about the 
    *  availability of the data. The frequency of this event is determined by the data 
    *  storage creation frequency and can not be set by the client. If the reporting mode is set 
    *  to both file and event both ways applies. 
    *  When a client receives an event of data availability, the client can retrieve the data, 
    *  by using the URL to make a connection to the system. 
    *  If reporting mode is set to <CODE>ReportMode.FILE_SINGLE</CODE> the reporting period specifies how 
    *  often measurement result report will be generated. 
    *  
    *  <p> 
    *  The report format defines the format of the result reports to be generated. 
    *  If the report mode is set to <CODE>ReportMode.FILE_MULTIPLE</CODE> or <CODE>EVENT_MULTIPLE</CODE> the 
    *  client should not set the report format, it will be assigned by the server. 
    *  
    *  <p> 
    *  The measurement schedule specifies the time frames during which the measurement job 
    *  will be active. The measurement job is active as soon as the start time - if supplied 
    *  in the schedule - is reached. The system shall support a measurement job start time of 
    *  up to at least 30 days from the measurement job creation date. If no start time is 
    *  provided, the measurement job shall become active immediately. The measurement job 
    *  remains active until the stop time - if supplied in the schedule - is reached. If no 
    *  measurement job stop time is specified the measurement job will run indefinitely and can 
    *  only be stopped by system intervention, i.e. by deleting or suspending the measurement 
    *  job. 
    *  The time frame defined by the measurement schedule may contain one or more recording 
    *  intervals. These recording intervals may repeat on a daily and/or weekly basis and 
    *  specify the time periods during which the measurement data is collected. The start time 
    *  and end time define a recording interval, which lie between 00.00 and 24.00 hours, 
    *  aligned on granularity period boundaries. Thus the length of a recording interval will 
    *  be a multiple of the granularity period. If daily interval is omitted, the measurement 
    *  job will run continuously through the day. If weekly schedule is omitted the measurement 
    *  job will run all days of the week. Alternatively the weekly schedule will indicate which 
    *  days of the week the measurement job will be run. 
    *  The timer-synchronization between the client and the server is not part of this 
    *  interface and is left over to the implementers. 
    *  
    *  <p> 
    *  The measurement job can have several states: Active and on duty, Active but of duty and 
    *  suspended. The following shows how the states are changed in accordance to the schedule. 
    *  
    *  <p> 
    *  (A) Duration (A schedule represents by startTime and stopTime) 
    *  <p> 
    *  State Transition table (1), the startTime and stopTime is set 
    *  <blockquote><pre> 
    *  ---------------------++------------------------+ 
    *  Time Stream || Operation | 
    *  || ---suspend()--> | 
    *  || <--resume()---- | 
    *  ---------------------++-----------+------------+ 
    *  1. before startTime || off-duty | suspended | 
    *  ---------------------++-----------+------------+<> startTime 
    *  2. within schedule || on-duty | suspended | 
    *  ---------------------++-----------+------------+<> stopTime 
    *  </blockquote></pre> 
    *  
    *  <p>State Transition table (2), the startTime is not set and the endTime is set. 
    *  <blockquote><pre> 
    *  ---------------------++------------------------+ 
    *  Time Stream || Operation | 
    *  || ---suspend()--> | 
    *  || <--resume()---- | 
    *  ---------------------++-----------+------------+<> startTime not set 
    *  1. within schedule || on-duty | suspended | 
    *  ---------------------++-----------+------------+<> stopTime 
    *  </blockquote></pre> 
    *  <p>If startTime is not set means that monitoring will start immediately. 
    *  
    *  <p>State Transition table (3), the startTime is set and the endTime is not set. 
    *  <blockquote><pre> 
    *  ---------------------++------------------------+ 
    *  Time Stream || Operation | 
    *  || ---suspend()--> | 
    *  || <--resume()---- | 
    *  ---------------------++-----------+------------+ 
    *  1. before startTime || off-duty | suspended | 
    *  ---------------------++-----------+------------+<> startTime 
    *  2. within schedule || on-duty | suspended | 
    *  ---------------------++-----------+------------+<> forever 
    *  </blockquote></pre> 
    *  
    *  <p>(B) Daily Scheduling 
    *  
    *  <p>The daily scheduling is set to have 4 elements, two start times and two stop times. 
    *  
    *  <p>State Transition table (4) 
    *  <blockquote><pre> 
    *  ---------------------++------------------------+ 
    *  Time Stream || Operation | 
    *  || ---suspend()--> | 
    *  || <--resume()---- | 
    *  ---------------------++-----------+------------+ 
    *  1. off schedule || off-duty | suspended | 
    *  ---------------------++-----------+------------+<> 1st element 
    *  2. within schedule || on-duty | suspended | 
    *  ---------------------++-----------+------------+<> 2nd element 
    *  3. off schedule || off-duty | suspended | 
    *  ---------------------++-----------+------------+<> 3rd element 
    *  4. within schedule || on-duty | suspended | 
    *  ---------------------++-----------+------------+<> final element 
    *  5. It will be back to 1. because of day-line crossing. 
    *  </blockquote></pre> 
    *  
    *  <p>(C) Weekly Scheduling 
    *  
    *  <p>The weekly scheduling is set to Monday and Friday and the daily scheduling is set 
    *  to have 4 elements, as above. 
    *  
    *  <p>State Transition table (5) 
    *  <blockquote><pre> 
    *  ---------------------++------------------------+ 
    *  Time Stream || Operation | 
    *  || ---suspend()--> | 
    *  || <--resume()---- | 
    *  ---------------------++-----------+------------+ 
    *  1. off schedule || off-duty | suspended | 
    *  on Sunday || | | 
    *  ---------------------++-----------+------------+ 
    *  2. off schedule || off-duty | suspended | 
    *  on Monday || | | 
    *  ---------------------++-----------+------------+<> 1st element 
    *  3. within schedule || on-duty | suspended | 
    *  ---------------------++-----------+------------+<> 2nd element 
    *  4. off schedule || off-duty | suspended | 
    *  ---------------------++-----------+------------+<> 3rd element 
    *  5. within schedule || on-duty | suspended | 
    *  ---------------------++-----------+------------+<> final element 
    *  6. off schedule || off-duty | suspended | 
    *  on Monday || | | 
    *  ---------------------++-----------+------------+ 
    *  7. off schedule || off-duty | suspended | 
    *  on Tuesday-Thursday || | | 
    *  ---------------------++-----------+------------+ 
    *  8. off schedule || off-duty | suspended | 
    *  on Friday || | | 
    *  ---------------------++-----------+------------+<> 1st element 
    *  9. within schedule || on-duty | suspended | 
    *  ---------------------++-----------+------------+<> 2nd element 
    *  10. off schedule || off-duty | suspended | 
    *  ---------------------++-----------+------------+<> 3rd element 
    *  11. within schedule || on-duty | suspended | 
    *  ---------------------++-----------+------------+<> final element 
    *  12. off schedule || off-duty | suspended | 
    *  on Friday || | | 
    *  ---------------------++-----------+------------+ 
    *  13. off schedule || off-duty | suspended | 
    *  on Saturday || | | 
    *  ---------------------++-----------+------------+ 
    *  14. It will be back to 1. because of weekly-line crossing. 
    *  </blockquote></pre>
    *
    *  @author: OSS through Java Initiative , Vincent Perrot Sun Microsystems Inc.
    *  @version: 1.3
    *  @since: March 2005
    *
    *
    *
    *
    */
public interface PerformanceMonitorValue
	extends javax.oss.cbe.EntityValue
{
	public static final String VALUE_TYPE = "javax.oss.cbe.measurement.PerformanceMonitorValue";
	public static final String PERFORMANCE_MONITOR_KEY = "performanceMonitorKey";


     public final static String NAME = "name";
     public final static String GRANULARITY_PERIOD = "granularityPeriod";
     public final static String REPORT_BY_FILE = "reportByFile";
     public final static String REPORT_BY_EVENT = "reportByEvent";
     public final static String REPORT_PERIOD = "reportPeriod";
     public final static String REPORT_FORMAT = "reportFormat";
     public final static String SCHEDULE = "schedule";
     public final static String STATE = "state";

	/**
     * Deep copy of this object
     */
    public Object clone();
   /**
    * 
    * Attribute getter for name
    *
    *** Automatically created by Tigerstripe workbench from user defined attribute: PerformanceMonitor.name ***
    *
    *
    * 
    * @return the value of the name field.
    * @throws java.lang.IllegalStateException - if the attribute is not populated.
    *     * 
    */
        public java.lang.String getName()
            throws
 	        java.lang.IllegalStateException
         ;

   /**
    * Attribute setter for name
    * 
    *  Sets the name of the measurement job. 
    *  
    *  <p> 
    *  The measurement name will be validated when the value object is passed 
    *  to the performance monitor bean. 
    *  
    *  <p> 
    *  The default value for the name is an empty string.
    * @param value - the value to use to set the name attribute.
    * @throws java.lang.IllegalArgumentException - Is thrown to report that a bad argument was provided to the method.
    *     *    
    */
	public void setName( java.lang.String value )
		throws java.lang.IllegalArgumentException;
   /**
    * 
    * Attribute getter for granularityPeriod
    *
    *** Automatically created by Tigerstripe workbench from user defined attribute: PerformanceMonitor.granularityPeriod ***
    *
    *
    * 
    * @return the value of the granularityPeriod field.
    * @throws java.lang.IllegalStateException - if the attribute is not populated.
    *     * 
    */
        public int getGranularityPeriod()
            throws
 	        java.lang.IllegalStateException
         ;

   /**
    * Attribute setter for granularityPeriod
    * 
    *  Sets the granularity period for the measurement job. 
    *  
    *  <p> 
    *  The granularity period is the time between the initiation of two successive 
    *  gatherings of measurement data, within the timeframe specified in the measurement 
    *  scheduling. Examples of granularity period can be 5 minutes, 15 minutes, 30 minutes, 
    *  1 hour. The granularity period of 5 minutes is used in most cases, but for some 
    *  measurements it may only make sense to collect data in a larger granularity period. 
    *  
    *  <p> 
    *  The granularity period will be validated when the value object is passed 
    *  to the performance monitor bean. 
    *  
    *  <p> 
    *  The granularity period is specified in seconds. The valid granularity periods can be 
    *  retrieved by calling <CODE>JVTPerformancMonitorSession.getSupportedGranularities()</CODE>.
    * @param value - the value to use to set the granularityPeriod attribute.
    * @throws java.lang.IllegalArgumentException - Is thrown to report that a bad argument was provided to the method.
    *     *    
    */
	public void setGranularityPeriod( int value )
		throws java.lang.IllegalArgumentException;
   /**
    * 
    * Attribute getter for reportByFile
    *
    *** Automatically created by Tigerstripe workbench from user defined attribute: PerformanceMonitor.reportByFile ***
    *
    *
    * 
    * @return the value of the reportByFile field.
    * @throws java.lang.IllegalStateException - if the attribute is not populated.
    *     * 
    */
        public int getReportByFile()
            throws
 	        java.lang.IllegalStateException
         ;

   /**
    * Attribute setter for reportByFile
    * 
    *  Sets the file reporting mode. 
    *  
    *  <p> 
    *  If the reporting mode is set to file, the measurement job will capture the 
    *  measurement result reports into a data storage and then emit an event to the client 
    *  about the availability of the data. The frequency of this event is determined by the 
    *  data storage creation frequency and can not be set by the client. When the client 
    *  receives the event of data availability, the client can retrieve the data, by using the 
    *  URL to make a connection to the system. 
    *  
    *  <p> 
    *  The default value for file report mode is <CODE>ReportMode.NO_REPORT_MODE</CODE>.
    * @param value - the value to use to set the reportByFile attribute.
    * @throws java.lang.IllegalArgumentException - Is thrown to report that a bad argument was provided to the method.
    *     *    
    */
	public void setReportByFile( int value )
		throws java.lang.IllegalArgumentException;
   /**
    * 
    * Attribute getter for reportByEvent
    *
    *** Automatically created by Tigerstripe workbench from user defined attribute: PerformanceMonitor.reportByEvent ***
    *
    *
    * 
    * @return the value of the reportByEvent field.
    * @throws java.lang.IllegalStateException - if the attribute is not populated.
    *     * 
    */
        public int getReportByEvent()
            throws
 	        java.lang.IllegalStateException
         ;

   /**
    * Attribute setter for reportByEvent
    * 
    *  Sets the event reporting mode. 
    *  
    *  <p> 
    *  If the reporting mode is set to event the system will emit a event that carries the 
    *  measurement result reports. 
    *  
    *  <p> 
    *  The default value for file report mode is <CODE>ReportMode.NO_REPORT_MODE</CODE>.
    * @param value - the value to use to set the reportByEvent attribute.
    * @throws java.lang.IllegalArgumentException - Is thrown to report that a bad argument was provided to the method.
    *     *    
    */
	public void setReportByEvent( int value )
		throws java.lang.IllegalArgumentException;
   /**
    * 
    * Attribute getter for reportPeriod
    *
    *** Automatically created by Tigerstripe workbench from user defined attribute: PerformanceMonitor.reportPeriod ***
    *
    *
    * 
    * @return the value of the reportPeriod field.
    * @throws java.lang.IllegalStateException - if the attribute is not populated.
    *     * 
    */
        public int getReportPeriod()
            throws
 	        java.lang.IllegalStateException
         ;

   /**
    * Attribute setter for reportPeriod
    * 
    *  Sets the reporting period of result report of the measurement job. 
    *  
    *  <p> 
    *  The reporting period specifies how often measurement result report will be generated 
    *  and is valid if reporting mode is set to <CODE>ReportMode.FILE_SINGLE</CODE>. 
    *  
    *  <p> 
    *  With the reporting mode set to <CODE>ReportMode.FILE_SINGLE</CODE>, the reporting period is the 
    *  number of granularity periods between the initiation of two successive result report 
    *  generation. The result report shall include all data that have been collected since 
    *  the last result report generation. 
    *  
    *  <p> 
    *  If the report period is not set, a value equal to the granularity period of the 
    *  measurement job is used. If reporting period is set to zero and report mode is set 
    *  only to <CODE>ReportMode.FILE_SINGLE</CODE> no reports will be generated.
    * @param value - the value to use to set the reportPeriod attribute.
    * @throws java.lang.IllegalArgumentException - Is thrown to report that a bad argument was provided to the method.
    *     *    
    */
	public void setReportPeriod( int value )
		throws java.lang.IllegalArgumentException;
   /**
    * 
    * Attribute getter for reportFormat
    *
    *** Automatically created by Tigerstripe workbench from user defined attribute: PerformanceMonitor.reportFormat ***
    *
    *
    * 
    * @return the value of the reportFormat field.
    * @throws java.lang.IllegalStateException - if the attribute is not populated.
    *     * 
    */
        public javax.oss.cbe.report.ReportFormat getReportFormat()
            throws
 	        java.lang.IllegalStateException
         ;
   /**
    * 
    * Attribute Type getter for reportFormat
    *
    * @return the valid set of types for the reportFormat field.
    * 
    */
       public String[] attributeTypeForReportFormat();

   /**
    * Attribute setter for reportFormat
    * 
    *  Sets the report format of the measurement job. 
    *  
    *  <p> 
    *  The report format defines the format of the result reports to be generated. 
    *  If the report mode is set to <CODE>ReportMode.FILE_MULTIPLE</CODE> or <CODE>EVENT_MULTIPLE</CODE> the 
    *  client should not set the report format. In this case the report format is that same as the 
    *  <CODE>JVTPerformanceMonitorSession.getCurrentReportFormat()</CODE> 
    *  
    *  <p> 
    *  The supported report format can be retrieved by using the <CODE>JVTPerformanceMonitorSession.getReportFormats()</CODE>.
    * @param value - the value to use to set the reportFormat attribute.
    * @throws java.lang.IllegalArgumentException - Is thrown to report that a bad argument was provided to the method.
    *     *    
    */
	public void setReportFormat( javax.oss.cbe.report.ReportFormat value )
		throws java.lang.IllegalArgumentException;
   /**
    * 
    * Attribute getter for schedule
    *
    *** Automatically created by Tigerstripe workbench from user defined attribute: PerformanceMonitor.schedule ***
    *
    *
    * 
    * @return the value of the schedule field.
    * @throws java.lang.IllegalStateException - if the attribute is not populated.
    *     * 
    */
        public javax.oss.cbe.schedule.Schedule getSchedule()
            throws
 	        java.lang.IllegalStateException
         ;
   /**
    * 
    * Attribute Type getter for schedule
    *
    * @return the valid set of types for the schedule field.
    * 
    */
       public String[] attributeTypeForSchedule();

   /**
    * Attribute setter for schedule
    * 
    *  Sets the schedule of the measurement job. 
    *  
    *  <p> 
    *  The measurement schedule specifies the time frames during which the measurement job 
    *  will be active. The measurement job is active as soon as the start time - if set - is 
    *  reached. If no start time is provided, the measurement job shall become active 
    *  immediately. The measurement job remains active until the stop time - if set - is 
    *  reached. If no stop time is specified the measurement job will run 
    *  indefinitely and can only be stopped by system intervention, i.e. by deleting or 
    *  suspending the measurement job. The time frame defined by the measurement schedule may 
    *  contain one or more recording intervals. These recording intervals may repeat on 
    *  weekly basis. If weekly schedule is omitted the measurement job will run all days of 
    *  the week. Alternatively the weekly schedule will indicate which days of the week the 
    *  measurement job will be run. The daily schedule of the measurement schedule specifies 
    *  the time frames during the day which the measurement job will be active. The time 
    *  frame defined by the measurement schedule may contain one or more recording intervals. 
    *  These recording intervals specify the time periods during which the measurement data 
    *  is collected. The start time and end time define a recording interval, which lie 
    *  between 00.00 and 24.00 hours, aligned on granularity period boundaries. Thus the 
    *  length of a recording interval will be a multiple of the granularity period. If daily 
    *  interval is omitted, the measurement job will run continuously through the day.
    * @param value - the value to use to set the schedule attribute.
    * @throws java.lang.IllegalArgumentException - Is thrown to report that a bad argument was provided to the method.
    *     *    
    */
	public void setSchedule( javax.oss.cbe.schedule.Schedule value )
		throws java.lang.IllegalArgumentException;
   /**
    * 
    * Attribute getter for state
    *
    *** Automatically created by Tigerstripe workbench from user defined attribute: PerformanceMonitor.state ***
    *
    * @ossj:enumerationfield class=javax.oss.cbe.measurement.PerformanceMonitorState
    * 
    * @return the value of the state field.
    * @throws java.lang.IllegalStateException - if the attribute is not populated.
    *     * 
    */
        public java.lang.String getState()
            throws
 	        java.lang.IllegalStateException
         ;

   /**
    * Attribute setter for state
    * 
    *  Sets the state of the measurement job.
    * @param state java.lang.String as given by one of the <CODE>PerformanceMonitorState</CODE> interface constant
    * @throws java.lang.IllegalArgumentException - Is thrown to report that a bad argument was provided to the method.
    *     *    
    */
	public void setState( java.lang.String value )
		throws java.lang.IllegalArgumentException;


    /**
    * Factory method for ReportFormat
    * 
    * @return a new instance of ReportFormat
    */
    public javax.oss.cbe.report.ReportFormat makeReportFormat(String typeToMake)
    	 throws java.lang.IllegalArgumentException;


    /**
    * Factory method for Schedule
    * 
    * @return a new instance of Schedule
    */
    public javax.oss.cbe.schedule.Schedule makeSchedule(String typeToMake)
    	 throws java.lang.IllegalArgumentException;


    /**
     * Gets the key for this value object
     *
     * @return the key for this value object
     * @throws java.lang.IllegalStateException if no key was populated in this
     *    value object.
     */
	public javax.oss.cbe.measurement.PerformanceMonitorKey getPerformanceMonitorKey()
	    throws java.lang.IllegalStateException;
	
	/**
	 * Sets the key for this value object
	 *
	 * @param key - the key to set on this value object.
	 * @throws java.lang.IllegalArgumentException, if the key is not a valid
	 *    key for this value object.
	 */
	public void setPerformanceMonitorKey( javax.oss.cbe.measurement.PerformanceMonitorKey key )
		throws java.lang.IllegalArgumentException;
	
    /**
     * Factory method for PerformanceMonitorKey
     *
     * @return a new instance of a blank PerformanceMonitorKey
     */
	public javax.oss.cbe.measurement.PerformanceMonitorKey makePerformanceMonitorKey();
	

}
