/**
 *	Generated with Tigerstripe(tm) v1.0.6
 *
 *  Tigerstripe(tm) is a registered trademark of Tigerstripe, Inc.
 *
 *	Plugin  : ts/ossj-jvt-spec (1.3)
 *	
 *  DO NOT EDIT THIS CODE WAS AUTOMATICALLY GENERATED
 *
 *  Generated from source Tigerstipe Artifact : javax.oss.cbe.measurement.ThresholdDefinition
 */

/*
Copyright 2002-2006 The Members of the OSS through Java(TM) Initiative.
All rights reserved. Use is subject to license terms.
*/
package javax.oss.cbe.measurement;
   /**
    *	Public interface definition for ThresholdDefinition
    *
    *  The Threshold Definition interface provides a mechanism for the configuration 
    *  of the parameters that specify the criteria that determines the setting and 
    *  the clearing of threshold crossing states (threshold crossed and threshold 
    *  cleared). A threshold enters a threshold crossed state when it reaches the 
    *  threshold value specified by the setValue operation. It will remain in this 
    *  state until it enters a threshold cleared state. A threshold cleared state is 
    *  achieved when a threshold reaches a value that is calculated using the 
    *  offset and the threshold value. If the direction of the threshold is 
    *  rising, the value is computed by subtracting the offset from the 
    *  threshold value. Once the threshold reaches this value, it will remain in a 
    *  threshold cleared state until it rises to the threshold value again. If the 
    *  direction is falling, the offset is added to the threshold value and it 
    *  will remain in the threshold cleared state until it descends to the threshold 
    *  value again. 
    *  
    *  <p> 
    *  The valid attribute types are defined in 
    *  <code>javax.oss.cbe.measurement.PerformanceAttributeDescriptor</code>. However the 
    *  <code>STRING</code> type is not allowed for a threshold attribute.
    *
    *  @author: OSS through Java Initiative, Vincent Perrot Sun Microsystems Inc.
    *  @version: 1.3
    *  @since: March 2005
    *  @see: PerformanceAttributeDescriptor
    *
    *
    *
    */
public interface ThresholdDefinition
	extends java.lang.Cloneable, java.io.Serializable
{

	public final static int RISING_DIRECTION = 0;
	public final static int FALLING_DIRECTION = 1;


    /**
     * Deep copy of this object
     */
    public Object clone();

	
   /**
    * 
    * Attribute getter for attributeDescriptor
    *
    *** Automatically created by Tigerstripe workbench from user defined attribute: ThresholdDefinition.attributeDescriptor ***
    *
    *
    * 
    * @return the value of the attributeDescriptor field.
    *     * 
    */
        public javax.oss.cbe.measurement.PerformanceAttributeDescriptor getAttributeDescriptor()
         ;
   /**
    * 
    * Attribute Type getter for attributeDescriptor
    *
    * @return the valid set of types for the attributeDescriptor field.
    * 
    */
       public String[] attributeTypeForAttributeDescriptor();

   /**
    * Attribute setter for attributeDescriptor
    * 
    *  Sets the attribute name to be monitored.
    * @param value - the value to use to set the attributeDescriptor attribute.
    * @throws java.lang.IllegalArgumentException - Is thrown to report that a bad argument was provided to the method.
    *     *    
    */
	public void setAttributeDescriptor( javax.oss.cbe.measurement.PerformanceAttributeDescriptor value )
		throws java.lang.IllegalArgumentException;
   /**
    * 
    * Attribute getter for value
    *
    *** Automatically created by Tigerstripe workbench from user defined attribute: ThresholdDefinition.value ***
    *
    *
    * 
    * @return the value of the value field.
    *     * 
    */
        public java.lang.Object getValue()
         ;

   /**
    * Attribute setter for value
    * 
    *  Sets the value that attributes values must reach in order to achieve 
    *  a threshold crossing state.
    * @param value - the value to use to set the value attribute.
    * @throws java.lang.IllegalArgumentException - Is thrown to report that a bad argument was provided to the method.
    *     *    
    */
	public void setValue( java.lang.Object value )
		throws java.lang.IllegalArgumentException;
   /**
    * 
    * Attribute getter for offset
    *
    *** Automatically created by Tigerstripe workbench from user defined attribute: ThresholdDefinition.offset ***
    *
    *
    * 
    * @return the value of the offset field.
    *     * 
    */
        public java.lang.Object getOffset()
         ;

   /**
    * Attribute setter for offset
    * 
    *  Sets the offset associated with the threshold definition. This value 
    *  along with the direction specifies the hysteresis that the attribute 
    *  value is allowed to oscillate within without being classified in a 
    *  threshold crossing state. If the threshold direction is rising, 
    *  the following applies: Once a threshold attribute enters 
    *  a threshold crossing state (reaches the threshold value), no 
    *  subsequent crossings are registered until the threshold 
    *  attribute value has descended to the value of the threshold value MINUS 
    *  the Offset. When it reaches this point, the threshold attribute is no longer 
    *  considered to be in a threshold crossing state and it enters a threshold 
    *  cleared state. 
    *  The reverse applies for the falling direction. 
    *  
    *  Note: Value and Offset MUST be of the same type.
    * @param value - the value to use to set the offset attribute.
    * @throws java.lang.IllegalArgumentException - Is thrown to report that a bad argument was provided to the method.
    *     *    
    */
	public void setOffset( java.lang.Object value )
		throws java.lang.IllegalArgumentException;
   /**
    * 
    * Attribute getter for direction
    *
    *** Automatically created by Tigerstripe workbench from user defined attribute: ThresholdDefinition.direction ***
    *
    *
    * 
    * @return the value of the direction field.
    *     * 
    */
        public int getDirection()
         ;

   /**
    * Attribute setter for direction
    * 
    *  Sets the direction of the threshold crossing associated with the 
    *  threshold definition. The direction is can be either rising or failing.
    * @param value - the value to use to set the direction attribute.
    * @throws java.lang.IllegalArgumentException - Is thrown to report that a bad argument was provided to the method.
    *     *    
    */
	public void setDirection( int value )
		throws java.lang.IllegalArgumentException;
   /**
    * 
    * Attribute getter for perceivedSeverity
    *
    *** Automatically created by Tigerstripe workbench from user defined attribute: ThresholdDefinition.perceivedSeverity ***
    *
    *
    * 
    * @return the value of the perceivedSeverity field.
    *     * 
    */
        public short getPerceivedSeverity()
         ;

   /**
    * Attribute setter for perceivedSeverity
    * 
    *  Sets the Perceived Severity associated with the 
    *  threshold definition.
    * @param value - the value to use to set the perceivedSeverity attribute.
    * @throws java.lang.IllegalArgumentException - Is thrown to report that a bad argument was provided to the method.
    *     *    
    */
	public void setPerceivedSeverity( short value )
		throws java.lang.IllegalArgumentException;


    /**
    * Factory method for PerformanceAttributeDescriptor
    * 
    * @return a new instance of PerformanceAttributeDescriptor
    */
    public javax.oss.cbe.measurement.PerformanceAttributeDescriptor makePerformanceAttributeDescriptor(String typeToMake)
    	 throws java.lang.IllegalArgumentException;


}
