/**
 *	Generated with Tigerstripe(tm) v1.0.6
 *
 *  Tigerstripe(tm) is a registered trademark of Tigerstripe, Inc.
 *
 *	Plugin  : ts/ossj-jvt-spec (1.3)
 *	
 *  DO NOT EDIT THIS CODE WAS AUTOMATICALLY GENERATED
 *
 *  Generated from source Tigerstipe Artifact : javax.oss.cbe.report.ReportInfoIterator
 */

/*
Copyright 2002-2006 The Members of the OSS through Java(TM) Initiative.
All rights reserved. Use is subject to license terms.
*/
package javax.oss.cbe.report;
   /**
    *	Public interface definition for ReportInfoIterator
    *
    *  This interface manages retrieval of information for multiple reports. 
    *  
    *  <p> 
    *  Because the query operation could potentially return large amounts of data, the iterator 
    *  design pattern is used for returning the results. An iterator is an object that is 
    *  created to contain the results of an operation. 
    *  The client receives a reference to the iterator as part of the information returned by 
    *  the query operation. The client then invokes operations on the iterator to receive 
    *  batches of results in sizes determined by the client. The iterator keeps track of how far 
    *  through the results the client has progressed. 
    *  
    *  <p> 
    *  The semantic of the iterator is that it is returning a snapshot of the data matching the 
    *  query expression at the moment the query was performed. If the underlying data are 
    *  modified while the iteration is in progress, it will not affect the behavior of the 
    *  iterator or the data values of the iterator. 
    *  
    *  <p> 
    *  The report information that is contained in this iterator must be sorted on report data 
    *  creation date. If the report data is stored in files, the oldest file shall be returned 
    *  first by the iterator.
    *
    *  @author: OSS through Java Initiative, Vincent Perrot Sun Microsystems Inc.
    *  @version: 1.3
    *  @since: March 2005
    *
    *
    *
    *
    */
public interface ReportInfoIterator
	extends java.lang.Cloneable, java.io.Serializable
{



    /**
     * Deep copy of this object
     */
    public Object clone();

	


    /**
    * getNext
    * 
    *  Returns a list of report information. 
    *  
    *  <p> 
    *  The function takes one argument that specifies the most number of items to return. 
    *  The implementation can decide to return less or the requested number of items. 
    *  
    *  <p> 
    *  If zero is specified and empty list is returned. 
    *  
    *  <p> 
    *  If the iteration is empty or has reached then end, an empty array is returned. 
    *  
    *  <p> 
    *  If the argument is greater than the number of item in the iterator then all or 
    *  implementation decided number of items are returned. 
    *  
    *  <p> 
    *  If the agreement plus the cursor of the iterator is greater than the number of item 
    *  in the iterator, all or implementation decided number of items from the cursor to the 
    *  end is returned.
    * 
    *
    */
    public javax.oss.cbe.report.ReportInfo[] getNext( 
	      int how_many
		) 
		throws
          java.rmi.RemoteException
		;
    /**
    * getNextReportInfos
    * 
    *  Returns a list of report information. 
    *  
    *  <p> 
    *  The function takes one argument that specifies the most number of items to return. 
    *  The implementation can decide to return less or the requested number of items. 
    *  <p> 
    *  If zero is specified and empty list is returned. 
    *  <p> 
    *  If the iteration is empty or has reached then end, an empty array is returned. 
    *  <p> 
    *  If the argument is greater than the number of item in the iterator then all or 
    *  implementation decided number of items are returned. 
    *  <p> 
    *  If the agreement plus the cursor of the iterator is greater than the number of item 
    *  in the iterator, all or implementation decided number of items from the cursor to the 
    *  end is returned.
    * 
    *
    */
    public javax.oss.cbe.report.ReportInfo[] getNextReportInfos( 
	      int how_many
		) 
		throws
          java.rmi.RemoteException
		;
    /**
    * remove
    * 
    *  Remove the iterator. 
    *  
    *  <p> 
    *  When the client has finished iterating through the collection, he shall call 
    *  this operation to allow resources to be freed.
    * 
    *
    */
    public void remove( 
		) 
		throws
          java.rmi.RemoteException
        , javax.ejb.RemoveException
		;
}
