/**
 *	Generated with Tigerstripe(tm) v1.0.6
 *
 *  Tigerstripe(tm) is a registered trademark of Tigerstripe, Inc.
 *
 *	Plugin  : ts/ossj-jvt-spec (1.3)
 *	
 *  DO NOT EDIT THIS CODE WAS AUTOMATICALLY GENERATED
 *
 *  Generated from source Tigerstipe Artifact : javax.oss.cbe.report.ReportMode
 */

/*
Copyright 2002-2006 The Members of the OSS through Java(TM) Initiative.
All rights reserved. Use is subject to license terms.
*/
package javax.oss.cbe.report;
   /**
    *	Public interface definition for ReportMode
    *
    *  Defines enumeration values for report mode. 
    *  
    *  <p> 
    *  The report modes, mainly comming from measurement definitions, can be done 
    *  in different ways. As example, the following measurement report modes exists: 
    *  <ul> 
    *  <li>event per measurement job. 
    *  <li>event for multiple measurement jobs. 
    *  <li>report file per measurement job. 
    *  <li>report file for multiple measurement jobs. 
    *  </ul> 
    *  
    *  <p> 
    *  The report mode can be divided into two major categories: by event and by file. If the 
    *  reporting mode is set to event the system will emit an event that carries the measurement 
    *  result report. If the reporting mode is set to file, the measurement job will capture the 
    *  measurement result reports into a data storage and then emit an event to the client about 
    *  the availability of the data. The frequency of this event is determined by the data 
    *  storage creation frequency. When a client receives an event of data availability, the client 
    *  can retrieve the data, by using the URL to connect to the system.
    *
    *  @author: OSS through Java Initiative, Vincent Perrot Sun Microsystems Inc.
    *  @version: 1.3
    *  @since: March 2005
    *  @see: javax.oss.cbe.measurement.PerformanceMonitorValue 
<P> 
<p> 
Two extra STREAM constants are added to indicate that 
the report is available as a stream-oriented data, instead of 
file or event based transfer mechanism. This is important for 
an API that supports stream oriented data and stream-oriented 
exchange protocol natively, for reporting. 
<p> 
Also, the support for stream oriented protocol makes it 
real-time report forwarding feasible with no inherent delays 
introduced by Activity Scheduling mechanism. 
<p> 
Example stream oriented protocols supported could include 
FTP, HTTP/HTTPS or low-level RAW SOCKET (or SSL socket) based transfers. 
The details of the actual transfer primitives are currently out of 
scope of 
this API specification and are left to individual implementaion. 
<p>
    *
    *
    *
    */
public interface ReportMode
	extends java.io.Serializable
{
	public final static int NO_REPORT_MODE = 0;
	public final static int EVENT_SINGLE = 1;
	public final static int EVENT_MULTIPLE = 2;
	public final static int FILE_SINGLE = 3;
	public final static int FILE_MULTIPLE = 4;
	public final static int STREAM_SINGLE = 5;
	public final static int STREAM_MULTIPLE = 6;
	public final static int ITERATOR_SINGLE = 7;
	public final static int ITERATOR_MULTIPLE = 8;
}
