/**
 *	Generated with Tigerstripe(tm) v1.0.6
 *
 *  Tigerstripe(tm) is a registered trademark of Tigerstripe, Inc.
 *
 *	Plugin  : ts/ossj-jvt-spec (1.3)
 *	
 *  DO NOT EDIT THIS CODE WAS AUTOMATICALLY GENERATED
 *
 *  Generated from source Tigerstipe Artifact : javax.oss.cbe.schedule.Schedule
 */

/*
Copyright 2002-2006 The Members of the OSS through Java(TM) Initiative.
All rights reserved. Use is subject to license terms.
*/
package javax.oss.cbe.schedule;
   /**
    *	Public interface definition for Schedule
    *
    *  Specifies the time frames during which the schedule will be active. 
    *  
    *  <p> 
    *  The schedule is active as soon as the start time - if supplied - is reached. The 
    *  schedule remains active until the stop time - if supplied - is reached. If no stop time 
    *  is specified the schedule will active indefinitely. 
    *  The time frame defined by the schedule may contain one or more intervals. These intervals 
    *  may repeat on a daily and/or weekly basis and specify the time periods during which the 
    *  schedule is active. A daily schedule includes a start time and end time, which lie between 
    *  00.00 and 24.00 hours. If daily schedule is omitted, the schedule will run continuously 
    *  through the day. If weekly schedule is omitted the schedule will run all days of the week. 
    *  Alternatively the weekly schedule will indicate which days of the week the schedule will 
    *  be active on. 
    *  
    *  <p> 
    *  The timer-synchronization between the client and the server is not part of this 
    *  interface and is left over to the implementers. However the implementations need to handle 
    *  different time zones.
    *
    *  @author: OSS through Java Initiative , Vincent Perrot Sun Microsystems Inc.
    *  @version: 1.3
    *  @since: March 2005
    *
    *
    *
    *
    */
public interface Schedule
	extends java.lang.Cloneable, java.io.Serializable
{



    /**
     * Deep copy of this object
     */
    public Object clone();

	
   /**
    * 
    * Attribute getter for startTime
    *
    *** Automatically created by Tigerstripe workbench from user defined attribute: Schedule.startTime ***
    *
    *
    * 
    * @return the value of the startTime field.
    *     * 
    */
        public java.util.Calendar getStartTime()
         ;

   /**
    * Attribute setter for startTime
    * 
    *  Sets the start time of the schedule. 
    *  
    *  <p> 
    *  The start time specifies when the schedule shall start to be active. 
    *  If no start time is provided, the schedule is active immediately. 
    *  
    *  <p> 
    *  If start time is null the start time will be cleared.
    * @param value - the value to use to set the startTime attribute.
    * @throws java.lang.IllegalArgumentException - Is thrown to report that a bad argument was provided to the method.
    *     *    
    */
	public void setStartTime( java.util.Calendar value )
		throws java.lang.IllegalArgumentException;
   /**
    * 
    * Attribute getter for stopTime
    *
    *** Automatically created by Tigerstripe workbench from user defined attribute: Schedule.stopTime ***
    *
    *
    * 
    * @return the value of the stopTime field.
    *     * 
    */
        public java.util.Calendar getStopTime()
         ;

   /**
    * Attribute setter for stopTime
    * 
    *  Sets the stop time of the schedule. 
    *  
    *  <p> 
    *  The stop time specifies when the schedule shall stop. The schedule will remain active 
    *  until the stop time - if set - is reached. If no stop time is specified the schedule 
    *  will be active indefinitely. 
    *  
    *  <p> 
    *  If stop time is null the stop time will be cleared.
    * @param value - the value to use to set the stopTime attribute.
    * @throws java.lang.IllegalArgumentException - Is thrown to report that a bad argument was provided to the method.
    *     *    
    */
	public void setStopTime( java.util.Calendar value )
		throws java.lang.IllegalArgumentException;
   /**
    * 
    * Attribute getter for weeklySchedule
    *
    *** Automatically created by Tigerstripe workbench from user defined attribute: Schedule.weeklySchedule ***
    *
    *
    * 
    * @return the value of the weeklySchedule field.
    *     * 
    */
        public javax.oss.cbe.schedule.WeeklySchedule getWeeklySchedule()
         ;
   /**
    * 
    * Attribute Type getter for weeklySchedule
    *
    * @return the valid set of types for the weeklySchedule field.
    * 
    */
       public String[] attributeTypeForWeeklySchedule();

   /**
    * Attribute setter for weeklySchedule
    * 
    *  Sets the weekly schedule of the schedule. 
    *  
    *  <p> 
    *  The weekly schedule specifies which day of the week the schedule will be active. 
    *  If weekly schedule is omitted the schedule will run all days of the week. 
    *  
    *  <p> 
    *  If weekly schedule is null the weekly schedule will be cleared.
    * @param value - the value to use to set the weeklySchedule attribute.
    * @throws java.lang.IllegalArgumentException - Is thrown to report that a bad argument was provided to the method.
    *     *    
    */
	public void setWeeklySchedule( javax.oss.cbe.schedule.WeeklySchedule value )
		throws java.lang.IllegalArgumentException;
   /**
    * 
    * Attribute getter for dailySchedule
    *
    *** Automatically created by Tigerstripe workbench from user defined attribute: Schedule.dailySchedule ***
    *
    *
    * 
    * @return the value of the dailySchedule field.
    *     * 
    */
        public javax.oss.cbe.schedule.DailySchedule getDailySchedule()
         ;
   /**
    * 
    * Attribute Type getter for dailySchedule
    *
    * @return the valid set of types for the dailySchedule field.
    * 
    */
       public String[] attributeTypeForDailySchedule();

   /**
    * Attribute setter for dailySchedule
    * 
    *  Sets the daily schedule of the schedule. 
    *  
    *  <p> 
    *  The daily schedule specifies the time frames during the day that the schedule will 
    *  be active. If daily schedule is omitted, the schedule will run continuously through 
    *  the day. 
    *  
    *  <p> 
    *  If daily schedule is null the daily schedule will be cleared.
    * @param value - the value to use to set the dailySchedule attribute.
    * @throws java.lang.IllegalArgumentException - Is thrown to report that a bad argument was provided to the method.
    *     *    
    */
	public void setDailySchedule( javax.oss.cbe.schedule.DailySchedule value )
		throws java.lang.IllegalArgumentException;
   /**
    * 
    * Attribute getter for active
    *
    *** Automatically created by Tigerstripe workbench from user defined attribute: Schedule.active ***
    *
    *
    * 
    * @return the value of the active field.
    *     * 
    */
        public boolean isActive()
         ;

   /**
    * 
    * Attribute getter for monthlySchedule
    *
    *** Automatically created by Tigerstripe workbench from user defined attribute: Schedule.monthlySchedule ***
    *
    *
    * 
    * @return the value of the monthlySchedule field.
    *     * 
    */
        public javax.oss.cbe.schedule.MonthlySchedule getMonthlySchedule()
         ;
   /**
    * 
    * Attribute Type getter for monthlySchedule
    *
    * @return the valid set of types for the monthlySchedule field.
    * 
    */
       public String[] attributeTypeForMonthlySchedule();

   /**
    * Attribute setter for monthlySchedule
    * 
    *  Sets the monthly schedule of the schedule. 
    *  
    *  <p> 
    *  The monthly schedule specifies the time frames during the month that the schedule will 
    *  be active. If month schedule is omitted, the schedule will run continuously through 
    *  the month. 
    *  
    *  <p> 
    *  If monthly schedule is null the monthly schedule will be cleared.
    * @param value - the value to use to set the monthlySchedule attribute.
    * @throws java.lang.IllegalArgumentException - Is thrown to report that a bad argument was provided to the method.
    *     *    
    */
	public void setMonthlySchedule( javax.oss.cbe.schedule.MonthlySchedule value )
		throws java.lang.IllegalArgumentException;
   /**
    * 
    * Attribute getter for annualSchedule
    *
    *** Automatically created by Tigerstripe workbench from user defined attribute: Schedule.annualSchedule ***
    *
    *
    * 
    * @return the value of the annualSchedule field.
    *     * 
    */
        public javax.oss.cbe.schedule.AnnualSchedule getAnnualSchedule()
         ;
   /**
    * 
    * Attribute Type getter for annualSchedule
    *
    * @return the valid set of types for the annualSchedule field.
    * 
    */
       public String[] attributeTypeForAnnualSchedule();

   /**
    * Attribute setter for annualSchedule
    * 
    *  Sets the annual schedule of the schedule. 
    *  
    *  <p> 
    *  The annual schedule specifies the time frames during the year that the schedule will 
    *  be active. If annual schedule is omitted, the schedule will run continuously through 
    *  the year. 
    *  <p> 
    *  If annual schedule is null the annual schedule will be cleared.
    * @param value - the value to use to set the annualSchedule attribute.
    * @throws java.lang.IllegalArgumentException - Is thrown to report that a bad argument was provided to the method.
    *     *    
    */
	public void setAnnualSchedule( javax.oss.cbe.schedule.AnnualSchedule value )
		throws java.lang.IllegalArgumentException;


    /**
    * Factory method for WeeklySchedule
    * 
    * @return a new instance of WeeklySchedule
    */
    public javax.oss.cbe.schedule.WeeklySchedule makeWeeklySchedule(String typeToMake)
    	 throws java.lang.IllegalArgumentException;


    /**
    * Factory method for DailySchedule
    * 
    * @return a new instance of DailySchedule
    */
    public javax.oss.cbe.schedule.DailySchedule makeDailySchedule(String typeToMake)
    	 throws java.lang.IllegalArgumentException;


    /**
    * Factory method for MonthlySchedule
    * 
    * @return a new instance of MonthlySchedule
    */
    public javax.oss.cbe.schedule.MonthlySchedule makeMonthlySchedule(String typeToMake)
    	 throws java.lang.IllegalArgumentException;


    /**
    * Factory method for AnnualSchedule
    * 
    * @return a new instance of AnnualSchedule
    */
    public javax.oss.cbe.schedule.AnnualSchedule makeAnnualSchedule(String typeToMake)
    	 throws java.lang.IllegalArgumentException;


}
