package ossj.common.ex;
import javax.ejb.EJB;
import javax.ejb.EJBException;
import javax.ejb.Stateless;
import javax.jws.WebService;
import javax.naming.InitialContext;
import org.ossj.wsdl.common.v1_4.ArrayOfString;
import org.ossj.wsdl.common.v1_4.EventPropertyDescriptor;
import org.ossj.wsdl.common.v1_4.GetEventDescriptorException;
import org.ossj.wsdl.common.v1_4.GetEventDescriptorException_Exception;
import org.ossj.wsdl.common.v1_4.GetEventDescriptorRequest;
import org.ossj.wsdl.common.v1_4.GetEventDescriptorResponse;
import org.ossj.wsdl.common.v1_4.GetEventTypesException;
import org.ossj.wsdl.common.v1_4.GetEventTypesException_Exception;
import org.ossj.wsdl.common.v1_4.GetEventTypesRequest;
import org.ossj.wsdl.common.v1_4.GetEventTypesResponse;
import org.ossj.wsdl.common.v1_4.GetManagedEntityTypesException;
import org.ossj.wsdl.common.v1_4.GetManagedEntityTypesException_Exception;
import org.ossj.wsdl.common.v1_4.GetManagedEntityTypesRequest;
import org.ossj.wsdl.common.v1_4.GetManagedEntityTypesResponse;
import org.ossj.wsdl.common.v1_4.GetNamedQueryTypesException;
import org.ossj.wsdl.common.v1_4.GetNamedQueryTypesException_Exception;
import org.ossj.wsdl.common.v1_4.GetNamedQueryTypesRequest;
import org.ossj.wsdl.common.v1_4.GetNamedQueryTypesResponse;
import org.ossj.wsdl.common.v1_4.GetSupportedOptionalOperationsException;
import org.ossj.wsdl.common.v1_4.GetSupportedOptionalOperationsException_Exception;
import org.ossj.wsdl.common.v1_4.GetSupportedOptionalOperationsRequest;
import org.ossj.wsdl.common.v1_4.GetSupportedOptionalOperationsResponse;
import org.ossj.wsdl.common.v1_4.GetUpdateProcedureTypesException;
import org.ossj.wsdl.common.v1_4.GetUpdateProcedureTypesException_Exception;
import org.ossj.wsdl.common.v1_4.GetUpdateProcedureTypesRequest;
import org.ossj.wsdl.common.v1_4.GetUpdateProcedureTypesResponse;
import org.ossj.wsdl.common.v1_4.QueryRequest;
import org.ossj.wsdl.common.v1_4.QueryResponse;
import org.ossj.wsdl.common.v1_4.RemoteException;
import org.ossj.wsdl.common.v1_4.UpdateRequest;
import org.ossj.wsdl.common.v1_4.UpdateResponse;

@Stateless
@WebService(serviceName = "JVTSessionWebService", portName = "JVTSessionWSPort", endpointInterface = "org.ossj.wsdl.common.v1_4.JVTSessionWSPort", targetNamespace = "http://ossj.org/wsdl/Common/v1-4", wsdlLocation = "META-INF/wsdl/JVTSessionWebService/OSSJ-Common-v1-4.wsdl")
public class JVTSessionWebService implements org.ossj.wsdl.common.v1_4.JVTSessionWSPort {
    
    @EJB(name="VpnServiceEJB")
    VpnServiceRemoteHome vpnHome;
    
    InitialContext initCtx = null;
    
    
    public GetSupportedOptionalOperationsResponse getSupportedOptionalOperations(GetSupportedOptionalOperationsRequest parameters) throws org.ossj.wsdl.common.v1_4.GetSupportedOptionalOperationsException_Exception {
        try {
            String[] types = null;
            try {
                types = getSession().getSupportedOptionalOperations();
                System.out.println("Got "+types.length);
            } catch (java.rmi.RemoteException rex) {
                rex.printStackTrace();
                throw new EJBException("RemoteException: " + rex.getMessage());
            }
            
            GetSupportedOptionalOperationsResponse res = new GetSupportedOptionalOperationsResponse();
            ArrayOfString aos = new ArrayOfString();
            for (int i = types.length -1; i >= 0; i--) {
                System.out.println("Got "+types[i]);
                aos.getItem().add(types[i]);
            }
            res.setStrings(aos);
            System.out.println("response = "+res.getStrings().getItem().isEmpty());
            return res;
        } catch (Exception e) {
            String msg = "Unable to getSupportedOptionalOperations...\n Exception :  ";
            RemoteException rex = new RemoteException();
            rex.setMessage(msg+e);
            GetSupportedOptionalOperationsException gmete = new GetSupportedOptionalOperationsException();
            gmete.setRemoteException(rex);
            throw new GetSupportedOptionalOperationsException_Exception(e.getMessage(),gmete);
        }
    }
    
    // @WebMethod
    public GetManagedEntityTypesResponse getManagedEntityTypes(GetManagedEntityTypesRequest parameters) throws org.ossj.wsdl.common.v1_4.GetManagedEntityTypesException_Exception {
        try {
            String[] types = null;
            try {
                types = getSession().getManagedEntityTypes();
                System.out.println("Got "+types.length);
            } catch (java.rmi.RemoteException rex) {
                rex.printStackTrace();
                throw new EJBException("RemoteException: " + rex.getMessage());
            }
            
            GetManagedEntityTypesResponse res = new GetManagedEntityTypesResponse();
            ArrayOfString aos = new ArrayOfString();
            for (int i = types.length -1; i >= 0; i--) {
                System.out.println("Got "+types[i]);
                aos.getItem().add(types[i]);
            }
            res.setStrings(aos);
            System.out.println("response = "+res.getStrings().getItem().isEmpty());
            return res;
        } catch (Exception e) {
            String msg = "Unable to getManagedEntityTypes...\n Exception :  ";
            RemoteException rex = new RemoteException();
            rex.setMessage(msg+e);
            GetManagedEntityTypesException gmete = new GetManagedEntityTypesException();
            gmete.setRemoteException(rex);
            throw new GetManagedEntityTypesException_Exception(e.getMessage(),gmete);
        }
    }
    
    public GetEventTypesResponse getEventTypes(GetEventTypesRequest parameters) throws org.ossj.wsdl.common.v1_4.GetEventTypesException_Exception {
        try {
            String[] types = null;
            try {
                types = getSession().getEventTypes();
                System.out.println("Got "+types.length);
            } catch (java.rmi.RemoteException rex) {
                rex.printStackTrace();
                throw new EJBException("RemoteException: " + rex.getMessage());
            }
            
            GetEventTypesResponse res = new GetEventTypesResponse();
            ArrayOfString aos = new ArrayOfString();
            for (int i = types.length -1; i >= 0; i--) {
                System.out.println("Got "+types[i]);
                aos.getItem().add(types[i]);
            }
            res.setStrings(aos);
            System.out.println("response = "+res.getStrings().getItem().isEmpty());
            return res;
        } catch (Exception e) {
            String msg = "Unable to getManagedEntityTypes...\n Exception :  ";
            RemoteException rex = new RemoteException();
            rex.setMessage(msg+e);
            GetEventTypesException gmete = new GetEventTypesException();
            gmete.setRemoteException(rex);
            throw new GetEventTypesException_Exception(e.getMessage(),gmete);
        }
    }
    
    public GetEventDescriptorResponse getEventDescriptor(GetEventDescriptorRequest parameters) throws org.ossj.wsdl.common.v1_4.GetEventDescriptorException_Exception {
        try {
            
            javax.oss.EventPropertyDescriptor evtpd = null;
            System.out.println("got event type = "+ parameters.getEventType());
            try {
                evtpd = getSession().getEventDescriptor(parameters.getEventType());
            } catch (java.rmi.RemoteException rex) {
                rex.printStackTrace();
                throw new EJBException("RemoteException: " + rex.getMessage());
            }
            
            GetEventDescriptorResponse res = new GetEventDescriptorResponse();
            EventPropertyDescriptor jaxevtpd = res.getEventPropertyDescriptor();
            jaxevtpd.setEventType(evtpd.getEventType());
            ArrayOfString aosNames = new ArrayOfString();
            String[] names = evtpd.getPropertyNames();
            for (int i = names.length -1; i >= 0; i--) {
                aosNames.getItem().add(names[i]);
            }
            jaxevtpd.setPropertyNames(aosNames);
            
            ArrayOfString aosTypes = new ArrayOfString();
            String[] types = evtpd.getPropertyTypes();
            for (int i = types.length -1; i >= 0; i--) {
                aosTypes.getItem().add(types[i]);
            }
            jaxevtpd.setPropertyTypes(aosTypes);
            
            res.setEventPropertyDescriptor(jaxevtpd);
            return res;
            
        } catch (Exception e) {
            String msg = "Unable to getManagedEntityTypes...\n Exception :  ";
            RemoteException rex = new RemoteException();
            rex.setMessage(msg+e);
            GetEventDescriptorException gmete = new GetEventDescriptorException();
            gmete.setRemoteException(rex);
            throw new GetEventDescriptorException_Exception(e.getMessage(),gmete);
        }
    }
    
    public UpdateResponse update(UpdateRequest parameters) throws org.ossj.wsdl.common.v1_4.UpdateException_Exception {
        return null;
    }
    
    public GetUpdateProcedureTypesResponse getUpdateProcedureTypes(GetUpdateProcedureTypesRequest parameters) throws org.ossj.wsdl.common.v1_4.GetUpdateProcedureTypesException_Exception {
        try {
            String[] types = null;
            try {
                types = getSession().getUpdateProcedureTypes();
                System.out.println("Got "+types.length);
            } catch (java.rmi.RemoteException rex) {
                rex.printStackTrace();
                throw new EJBException("RemoteException: " + rex.getMessage());
            }
            
            GetUpdateProcedureTypesResponse res = new GetUpdateProcedureTypesResponse();
            ArrayOfString aos = new ArrayOfString();
            for (int i = types.length -1; i >= 0; i--) {
                System.out.println("Got "+types[i]);
                aos.getItem().add(types[i]);
            }
            res.setStrings(aos);
            System.out.println("response = "+res.getStrings().getItem().isEmpty());
            return res;
        } catch (Exception e) {
            String msg = "Unable to getManagedEntityTypes...\n Exception :  ";
            RemoteException rex = new RemoteException();
            rex.setMessage(msg+e);
            GetUpdateProcedureTypesException gmete = new GetUpdateProcedureTypesException();
            gmete.setRemoteException(rex);
            throw new GetUpdateProcedureTypesException_Exception(e.getMessage(),gmete);
        }
    }
    
    public QueryResponse query(QueryRequest parameters) throws org.ossj.wsdl.common.v1_4.QueryException_Exception {
        return null;
    }
    
    public GetNamedQueryTypesResponse getNamedQueryTypes(GetNamedQueryTypesRequest parameters) throws org.ossj.wsdl.common.v1_4.GetNamedQueryTypesException_Exception {
        try {
            String[] types = null;
            try {
                types = getSession().getNamedQueryTypes();
                System.out.println("Got "+types.length);
            } catch (java.rmi.RemoteException rex) {
                rex.printStackTrace();
                throw new EJBException("RemoteException: " + rex.getMessage());
            }
            
            GetNamedQueryTypesResponse res = new GetNamedQueryTypesResponse();
            ArrayOfString aos = new ArrayOfString();
            for (int i = types.length -1; i >= 0; i--) {
                System.out.println("Got "+types[i]);
                aos.getItem().add(types[i]);
            }
            res.setStrings(aos);
            System.out.println("response = "+res.getStrings().getItem().isEmpty());
            return res;
        } catch (Exception e) {
            String msg = "Unable to getManagedEntityTypes...\n Exception :  ";
            RemoteException rex = new RemoteException();
            rex.setMessage(msg+e);
            GetNamedQueryTypesException gmete = new GetNamedQueryTypesException();
            gmete.setRemoteException(rex);
            throw new GetNamedQueryTypesException_Exception(e.getMessage(),gmete);
        }
    }
    
    
    private VpnServiceRemote getSession() throws javax.ejb.CreateException, javax.naming.NamingException {
        
        if (initCtx == null) initCtx = new InitialContext();
        
        //vpnHome = (VpnServiceRemoteHome)initCtx.lookup("ejb/VpnServiceBean");
        vpnHome = (VpnServiceRemoteHome)initCtx.lookup("System/System1/ApplicationType/Common/Application/1-4;1-4;ReferenceImplementation/Comp/VpnServiceBean");
        if (vpnHome == null){
            throw new javax.ejb.CreateException("Lookup of VpnServiceRemoteHome failed");
        }
        
        try {
            return vpnHome.create();
        } catch (java.rmi.RemoteException rex) {
            rex.printStackTrace();
            throw new EJBException("RemoteException: " + rex.getMessage());
        }
    }
}

