/*
Copyright 2002-2006 The Members of the OSS through Java(TM) Initiative.
All rights reserved. Use is subject to license terms.
*/
package ossj.common.cbe.customer;

import javax.oss.cbe.customer.CustomerKey;


/**
 * An implementation class for the <CODE>javax.oss.cbe.customer.CustomerKey</CODE> interface.  
 * 
 * @see javax.oss.cbe.customer.CustomerKey
 * 
 * @author OSS through Java(tm) Initiative, Vincent Perrot Sun Microsystems Inc.
 * @version 1.3 
 * @since January 2006 
 */


public class CustomerKeyImpl
extends ossj.common.cbe.party.PartyRoleKeyImpl
implements CustomerKey
{ 

    /**
     * Constructs a new CustomerKeyImpl with empty attributes.
     * 
     */

    public CustomerKeyImpl() {
        super();
    }



    /**
     * Creates a new object of the same class and with the same contents as this object.
     * @return a clone of this instance.
    */
    public Object clone() {
        CustomerKey val = null;
            val = (CustomerKey)super.clone();

            return val;
    }

    /**
     * Checks whether two CustomerKey are equal.
     * The result is true if and only if the argument is not null 
     * and is an CustomerKey object that has the arguments.
     * 
     * @param value the Object to compare with this CustomerKey
     * @return if the objects are equal; false otherwise.
     */

    public boolean equals (Object value) {
        if ( this == value ){ return true;}
        if ( (value != null) && ( value instanceof CustomerKey)) {
            CustomerKey argVal = (CustomerKey) value;

            return super.equals(argVal);
        } else {
            return super.equals(value);
        }
    }

}
