/*
Copyright 2002-2006 The Members of the OSS through Java(TM) Initiative.
All rights reserved. Use is subject to license terms.
*/
package ossj.common.cbe.customer;

import javax.oss.cbe.customer.CustomerServiceLevelAgreementKey;
import javax.oss.cbe.customer.CustomerServiceLevelAgreementValue;
import ossj.common.AttributeManager;
import ossj.common.Utils;


/**
 * An implementation class for the <CODE>javax.oss.cbe.customer.CustomerServiceLevelAgreementValue</CODE> interface.  
 * 
 * @see javax.oss.AttributeAccess
 * 
 * @see javax.oss.cbe.customer.CustomerServiceLevelAgreementValue
 * 
 * @see javax.oss.ManagedEntityValue
 * 
 * @author OSS through Java(tm) Initiative, Vincent Perrot Sun Microsystems Inc.
 * @version 1.3 
 * @since January 2006 
 */


public class CustomerServiceLevelAgreementValueImpl
extends ossj.common.cbe.sla.ServiceLevelAgreementValueImpl
implements CustomerServiceLevelAgreementValue
{ 

    /**
     * Constructs a new CustomerServiceLevelAgreementValueImpl with empty attributes.
     * 
     */

    public CustomerServiceLevelAgreementValueImpl() {
        super();
        setManagedEntityKeyInstance( new CustomerServiceLevelAgreementKeyImpl());
        initAttributeTypes();
    }

    private static final String[] attributeNames = {
    };

    private static final String[] settableAttributeNames = {
    };

    //
    // Configuration of AttributeManager and AttributeAccess
    //
    protected void addAttributesTo(AttributeManager anAttributeManager) {
        if (CustomerServiceLevelAgreementValueImpl.attributeNames != null) {
            anAttributeManager.addAttributes(this.attributeNames);
            super.addAttributesTo(anAttributeManager);
        }
    }

    protected void configureAttributes(AttributeManager anAttributeManager) {
        if (CustomerServiceLevelAgreementValueImpl.settableAttributeNames != null) {
            anAttributeManager.setSettableAttributes(CustomerServiceLevelAgreementValueImpl.settableAttributeNames);
            super.configureAttributes(anAttributeManager);
        }
    }

    /**
     * Holds the Attribute manager that manage the optional fields
    */
    private static AttributeManager attributemanager = null;

    protected AttributeManager getAttributeManager() {
        return attributemanager;
    }
    protected AttributeManager makeAttributeManager() {
        attributemanager = new AttributeManager();
        return attributemanager;
    }

    
    //==================================================================
    // FACTORIES AND ATTRIBUTE TYPE FOR ================================
    //==================================================================
    
    public javax.oss.cbe.customer.CustomerServiceLevelAgreementKey makeCustomerServiceLevelAgreementKey(){
        return (CustomerServiceLevelAgreementKey) makeManagedEntityKey();
    }

    /**
     * Init the Map Attribute Name/Attribute Type
     * Init the enumeration Map
     */
    protected void initAttributeTypes(){
        String[] list = new String[1];
    }



    /**
     * Changes the customerServiceLevelAgreementKey to be equal to the given argument.
     * 
     * This method support a null argument.
     * 
     * @param value the new customerServiceLevelAgreementKey for this object.
     * @exception java.lang.IllegalArgumentException - Is thrown to report
     * that a bad argument was provided to the method.
    */

    public void setCustomerServiceLevelAgreementKey(javax.oss.cbe.customer.CustomerServiceLevelAgreementKey value)
    throws java.lang.IllegalArgumentException    {
        setServiceLevelAgreementKey(value);
    }


    /**
     * Returns this CustomerServiceLevelAgreementValueImpl's customerServiceLevelAgreementKey
     * 
     * @return the customerServiceLevelAgreementKey
     * 
    */

    public javax.oss.cbe.customer.CustomerServiceLevelAgreementKey getCustomerServiceLevelAgreementKey()
    throws java.lang.IllegalStateException {
        return (javax.oss.cbe.customer.CustomerServiceLevelAgreementKey)getServiceLevelAgreementKey();
    }

    /**
     * Creates a new object of the same class and with the same contents as this object.
     * @return a clone of this instance.
    */
    public Object clone() {
        CustomerServiceLevelAgreementValue val = null;
            val = (CustomerServiceLevelAgreementValue)super.clone();

            return val;
    }

    /**
     * Checks whether two CustomerServiceLevelAgreementValue are equal.
     * The result is true if and only if the argument is not null 
     * and is an CustomerServiceLevelAgreementValue object that has the arguments.
     * 
     * @param value the Object to compare with this CustomerServiceLevelAgreementValue
     * @return if the objects are equal; false otherwise.
     */

    public boolean equals (Object value) {
        if ( this == value ){ return true;}
        if ( (value != null) && ( value instanceof CustomerServiceLevelAgreementValue)) {
            CustomerServiceLevelAgreementValue argVal = (CustomerServiceLevelAgreementValue) value;
            return Utils.compareAttributeAccess( this, argVal );
        }
        return false;
    }

}
