/*
Copyright 2002-2006 The Members of the OSS through Java(TM) Initiative.
All rights reserved. Use is subject to license terms.
*/
package ossj.common.cbe.customer;

import javax.oss.cbe.customer.CustomerServiceLevelAgreementValue;
import javax.oss.cbe.customer.CustomerServiceLevelAgreementValueIterator;


/**
 * An implementation class for the <CODE>javax.oss.cbe.customer.CustomerServiceLevelAgreementValueIterator</CODE> interface.  
 * 
 * @see javax.oss.cbe.customer.CustomerServiceLevelAgreementValueIterator
 * 
 * @author OSS through Java(tm) Initiative, Vincent Perrot Sun Microsystems Inc.
 * @version 1.3 
 * @since January 2006 
 */


public class CustomerServiceLevelAgreementValueIteratorImpl
extends ossj.common.cbe.sla.ServiceLevelAgreementValueIteratorImpl
implements CustomerServiceLevelAgreementValueIterator
{ 

    /**
     * Constructs a new CustomerServiceLevelAgreementValueIteratorImpl with empty attributes.
     * 
     */

    public CustomerServiceLevelAgreementValueIteratorImpl() {
        super();
    }

    /**
     * Constructs a new CustomerServiceLevelAgreementValueIteratorImpl and add the given values.
     * @param values, the array of values
     *
     */
    public CustomerServiceLevelAgreementValueIteratorImpl(CustomerServiceLevelAgreementValue[] values){
        super(values);
    }

    /** 
     * Returns the next specified number of elements in the iteration. 
     * @param howMany number of element to return
     * @return the array of howMany elements
     * @throws java.rmi.RemoteException
     * @see javax.oss.ManagedEntityValueIterator#getNext(int)
     */
    public CustomerServiceLevelAgreementValue[] getNextCustomerServiceLevelAgreements(int howMany)
    throws java.rmi.RemoteException {
        return (CustomerServiceLevelAgreementValue[]) getNext(howMany);
    }




}
