/*
Copyright 2002-2006 The Members of the OSS through Java(TM) Initiative.
All rights reserved. Use is subject to license terms.
*/
package ossj.common.cbe.customer;

import javax.oss.cbe.customer.CustomerValue;
import javax.oss.cbe.customer.CustomerValueIterator;


/**
 * An implementation class for the <CODE>javax.oss.cbe.customer.CustomerValueIterator</CODE> interface.  
 * 
 * @see javax.oss.cbe.customer.CustomerValueIterator
 * 
 * @author OSS through Java(tm) Initiative, Vincent Perrot Sun Microsystems Inc.
 * @version 1.3 
 * @since January 2006 
 */


public class CustomerValueIteratorImpl
extends ossj.common.cbe.party.PartyRoleValueIteratorImpl
implements CustomerValueIterator
{ 

    /**
     * Constructs a new CustomerValueIteratorImpl with empty attributes.
     * 
     */

    public CustomerValueIteratorImpl() {
        super();
    }

    /**
     * Constructs a new CustomerValueIteratorImpl and add the given values.
     * @param values, the array of values
     *
     */
    public CustomerValueIteratorImpl(CustomerValue[] values){
        super(values);
    }

    /** 
     * Returns the next specified number of elements in the iteration. 
     * @param howMany number of element to return
     * @return the array of howMany elements
     * @throws java.rmi.RemoteException
     * @see javax.oss.ManagedEntityValueIterator#getNext(int)
     */
    public CustomerValue[] getNextCustomers(int howMany)
    throws java.rmi.RemoteException {
        return (CustomerValue[]) getNext(howMany);
    }




}
