/*
Copyright 2002-2006 The Members of the OSS through Java(TM) Initiative.
All rights reserved. Use is subject to license terms.
*/
package ossj.common.cbe.product.productoffering;

import javax.oss.cbe.product.productoffering.ProductCatalogCharacteristicKey;
import javax.oss.cbe.product.productoffering.ProductCatalogCharacteristicValue;
import ossj.common.AttributeManager;
import ossj.common.Utils;


/**
 * An implementation class for the <CODE>javax.oss.cbe.product.productoffering.ProductCatalogCharacteristicValue</CODE> interface.  
 * 
 * @see javax.oss.AttributeAccess
 * 
 * @see javax.oss.cbe.product.productoffering.ProductCatalogCharacteristicValue
 * 
 * @see javax.oss.ManagedEntityValue
 * 
 * @author OSS through Java(tm) Initiative, Vincent Perrot Sun Microsystems Inc.
 * @version 1.3 
 * @since January 2006 
 */


public class ProductCatalogCharacteristicValueImpl
extends ossj.common.cbe.EntityValueImpl
implements ProductCatalogCharacteristicValue
{ 

    /**
     * Constructs a new ProductCatalogCharacteristicValueImpl with empty attributes.
     * 
     */

    public ProductCatalogCharacteristicValueImpl() {
        super();
        setManagedEntityKeyInstance( new ProductCatalogCharacteristicKeyImpl());
        initAttributeTypes();
    }

    private static final String[] attributeNames = {
        ProductCatalogCharacteristicValue.ID,
        ProductCatalogCharacteristicValue.NAME,
        ProductCatalogCharacteristicValue.PRESENCE,
    };

    private static final String[] settableAttributeNames = {
        ProductCatalogCharacteristicValue.ID,
        ProductCatalogCharacteristicValue.NAME,
        ProductCatalogCharacteristicValue.PRESENCE,
    };

    //
    // Configuration of AttributeManager and AttributeAccess
    //
    protected void addAttributesTo(AttributeManager anAttributeManager) {
        if (ProductCatalogCharacteristicValueImpl.attributeNames != null) {
            anAttributeManager.addAttributes(this.attributeNames);
            super.addAttributesTo(anAttributeManager);
        }
    }

    protected void configureAttributes(AttributeManager anAttributeManager) {
        if (ProductCatalogCharacteristicValueImpl.settableAttributeNames != null) {
            anAttributeManager.setSettableAttributes(ProductCatalogCharacteristicValueImpl.settableAttributeNames);
            super.configureAttributes(anAttributeManager);
        }
    }

    /**
     * Holds the Attribute manager that manage the optional fields
    */
    private static AttributeManager attributemanager = null;

    protected AttributeManager getAttributeManager() {
        return attributemanager;
    }
    protected AttributeManager makeAttributeManager() {
        attributemanager = new AttributeManager();
        return attributemanager;
    }

    
    //==================================================================
    // FACTORIES AND ATTRIBUTE TYPE FOR ================================
    //==================================================================
    
    public javax.oss.cbe.product.productoffering.ProductCatalogCharacteristicKey makeProductCatalogCharacteristicKey(){
        return (ProductCatalogCharacteristicKey) makeManagedEntityKey();
    }

    /**
     * Init the Map Attribute Name/Attribute Type
     * Init the enumeration Map
     */
    protected void initAttributeTypes(){
        String[] list = new String[1];
        list[0] = "java.lang.String";
        addAttributeTypes("presence", list);
        list[0] = "java.lang.String";
        addAttributeTypes("name", list);
        list[0] = "java.lang.String";
        addAttributeTypes("id", list);
    }

    private java.lang.String _productcatalogcharacteristicvalueimpl_id = null;
    private java.lang.String _productcatalogcharacteristicvalueimpl_name = null;
    private java.lang.String _productcatalogcharacteristicvalueimpl_presence = null;


    /**
     * Changes the id to be equal to the given argument.
     * 
     * This method support a null argument.
     * 
     * @param value the new id for this object.
     * @exception java.lang.IllegalArgumentException - Is thrown to report
     * that a bad argument was provided to the method.
    */

    public void setId(java.lang.String value)
    throws java.lang.IllegalArgumentException    {
        setDirtyAttribute(ProductCatalogCharacteristicValue.ID);
        _productcatalogcharacteristicvalueimpl_id = value;
    }


    /**
     * Returns this ProductCatalogCharacteristicValueImpl's id
     * 
     * @return the id
     * 
    */

    public java.lang.String getId()
    throws java.lang.IllegalStateException {
        checkAttribute(ProductCatalogCharacteristicValue.ID);
        return _productcatalogcharacteristicvalueimpl_id;
    }

    /**
     * Changes the name to be equal to the given argument.
     * 
     * This method support a null argument.
     * 
     * @param value the new name for this object.
     * @exception java.lang.IllegalArgumentException - Is thrown to report
     * that a bad argument was provided to the method.
    */

    public void setName(java.lang.String value)
    throws java.lang.IllegalArgumentException    {
        setDirtyAttribute(ProductCatalogCharacteristicValue.NAME);
        _productcatalogcharacteristicvalueimpl_name = value;
    }


    /**
     * Returns this ProductCatalogCharacteristicValueImpl's name
     * 
     * @return the name
     * 
    */

    public java.lang.String getName()
    throws java.lang.IllegalStateException {
        checkAttribute(ProductCatalogCharacteristicValue.NAME);
        return _productcatalogcharacteristicvalueimpl_name;
    }

    /**
     * Changes the presence to be equal to the given argument.
     * 
     * This method support a null argument.
     * 
     * @param value the new presence for this object.
     * @exception java.lang.IllegalArgumentException - Is thrown to report
     * that a bad argument was provided to the method.
    */

    public void setPresence(java.lang.String value)
    throws java.lang.IllegalArgumentException    {
        setDirtyAttribute(ProductCatalogCharacteristicValue.PRESENCE);
        _productcatalogcharacteristicvalueimpl_presence = value;
    }


    /**
     * Returns this ProductCatalogCharacteristicValueImpl's presence
     * 
     * @return the presence
     * 
    */

    public java.lang.String getPresence()
    throws java.lang.IllegalStateException {
        checkAttribute(ProductCatalogCharacteristicValue.PRESENCE);
        return _productcatalogcharacteristicvalueimpl_presence;
    }

    /**
     * Changes the productCatalogCharacteristicKey to be equal to the given argument.
     * 
     * This method support a null argument.
     * 
     * @param value the new productCatalogCharacteristicKey for this object.
     * @exception java.lang.IllegalArgumentException - Is thrown to report
     * that a bad argument was provided to the method.
    */

    public void setProductCatalogCharacteristicKey(javax.oss.cbe.product.productoffering.ProductCatalogCharacteristicKey value)
    throws java.lang.IllegalArgumentException    {
        setEntityKey(value);
    }


    /**
     * Returns this ProductCatalogCharacteristicValueImpl's productCatalogCharacteristicKey
     * 
     * @return the productCatalogCharacteristicKey
     * 
    */

    public javax.oss.cbe.product.productoffering.ProductCatalogCharacteristicKey getProductCatalogCharacteristicKey()
    throws java.lang.IllegalStateException {
        return (javax.oss.cbe.product.productoffering.ProductCatalogCharacteristicKey)getEntityKey();
    }

    /**
     * Creates a new object of the same class and with the same contents as this object.
     * @return a clone of this instance.
    */
    public Object clone() {
        ProductCatalogCharacteristicValue val = null;
            val = (ProductCatalogCharacteristicValue)super.clone();

            if( isPopulated(ProductCatalogCharacteristicValue.ID)) {
                if( this.getId()!=null) 
                    val.setId(((java.lang.String) new String( this.getId())));
                else
                    val.setId( null );
            }

            if( isPopulated(ProductCatalogCharacteristicValue.NAME)) {
                if( this.getName()!=null) 
                    val.setName(((java.lang.String) new String( this.getName())));
                else
                    val.setName( null );
            }

            if( isPopulated(ProductCatalogCharacteristicValue.PRESENCE)) {
                if( this.getPresence()!=null) 
                    val.setPresence(((java.lang.String) new String( this.getPresence())));
                else
                    val.setPresence( null );
            }

            return val;
    }

    /**
     * Checks whether two ProductCatalogCharacteristicValue are equal.
     * The result is true if and only if the argument is not null 
     * and is an ProductCatalogCharacteristicValue object that has the arguments.
     * 
     * @param value the Object to compare with this ProductCatalogCharacteristicValue
     * @return if the objects are equal; false otherwise.
     */

    public boolean equals (Object value) {
        if ( this == value ){ return true;}
        if ( (value != null) && ( value instanceof ProductCatalogCharacteristicValue)) {
            ProductCatalogCharacteristicValue argVal = (ProductCatalogCharacteristicValue) value;
            return Utils.compareAttributeAccess( this, argVal );
        }
        return false;
    }

}
