/*
Copyright 2002-2006 The Members of the OSS through Java(TM) Initiative.
All rights reserved. Use is subject to license terms.
*/
package ossj.common.cbe.product.productoffering;

import javax.oss.cbe.product.productoffering.ProductCatalogCharacteristicValue;
import javax.oss.cbe.product.productoffering.ProductCatalogCharacteristicValueIterator;


/**
 * An implementation class for the <CODE>javax.oss.cbe.product.productoffering.ProductCatalogCharacteristicValueIterator</CODE> interface.  
 * 
 * @see javax.oss.cbe.product.productoffering.ProductCatalogCharacteristicValueIterator
 * 
 * @author OSS through Java(tm) Initiative, Vincent Perrot Sun Microsystems Inc.
 * @version 1.3 
 * @since January 2006 
 */


public class ProductCatalogCharacteristicValueIteratorImpl
extends ossj.common.cbe.EntityValueIteratorImpl
implements ProductCatalogCharacteristicValueIterator
{ 

    /**
     * Constructs a new ProductCatalogCharacteristicValueIteratorImpl with empty attributes.
     * 
     */

    public ProductCatalogCharacteristicValueIteratorImpl() {
        super();
    }

    /**
     * Constructs a new ProductCatalogCharacteristicValueIteratorImpl and add the given values.
     * @param values, the array of values
     *
     */
    public ProductCatalogCharacteristicValueIteratorImpl(ProductCatalogCharacteristicValue[] values){
        super(values);
    }

    /** 
     * Returns the next specified number of elements in the iteration. 
     * @param howMany number of element to return
     * @return the array of howMany elements
     * @throws java.rmi.RemoteException
     * @see javax.oss.ManagedEntityValueIterator#getNext(int)
     */
    public ProductCatalogCharacteristicValue[] getNextProductCatalogCharacteristics(int howMany)
    throws java.rmi.RemoteException {
        return (ProductCatalogCharacteristicValue[]) getNext(howMany);
    }




}
