/*
Copyright 2002-2006 The Members of the OSS through Java(TM) Initiative.
All rights reserved. Use is subject to license terms.
*/
package ossj.common.cbe.product.productoffering;

import javax.oss.cbe.product.productoffering.ProductCatalogCharacteristicValueKey;
import javax.oss.cbe.datatypes.TimePeriod;
import ossj.common.cbe.datatypes.TimePeriodImpl;
import javax.oss.cbe.product.productoffering.ProductCatalogCharacteristicValueValue;
import ossj.common.AttributeManager;
import ossj.common.Utils;


/**
 * An implementation class for the <CODE>javax.oss.cbe.product.productoffering.ProductCatalogCharacteristicValueValue</CODE> interface.  
 * 
 * @see javax.oss.AttributeAccess
 * 
 * @see javax.oss.cbe.product.productoffering.ProductCatalogCharacteristicValueValue
 * 
 * @see javax.oss.ManagedEntityValue
 * 
 * @author OSS through Java(tm) Initiative, Vincent Perrot Sun Microsystems Inc.
 * @version 1.3 
 * @since January 2006 
 */


public class ProductCatalogCharacteristicValueValueImpl
extends ossj.common.cbe.EntityValueImpl
implements ProductCatalogCharacteristicValueValue
{ 

    /**
     * Constructs a new ProductCatalogCharacteristicValueValueImpl with empty attributes.
     * 
     */

    public ProductCatalogCharacteristicValueValueImpl() {
        super();
        setManagedEntityKeyInstance( new ProductCatalogCharacteristicValueKeyImpl());
        initAttributeTypes();
    }

    private static final String[] attributeNames = {
        ProductCatalogCharacteristicValueValue.TYPE,
        ProductCatalogCharacteristicValueValue.VALID_FOR,
        ProductCatalogCharacteristicValueValue.VALUE,
        ProductCatalogCharacteristicValueValue.VALUE_FROM,
        ProductCatalogCharacteristicValueValue.VALUE_TO
    };

    private static final String[] settableAttributeNames = {
        ProductCatalogCharacteristicValueValue.TYPE,
        ProductCatalogCharacteristicValueValue.VALID_FOR,
        ProductCatalogCharacteristicValueValue.VALUE,
        ProductCatalogCharacteristicValueValue.VALUE_FROM,
        ProductCatalogCharacteristicValueValue.VALUE_TO
    };

    //
    // Configuration of AttributeManager and AttributeAccess
    //
    protected void addAttributesTo(AttributeManager anAttributeManager) {
        if (ProductCatalogCharacteristicValueValueImpl.attributeNames != null) {
            anAttributeManager.addAttributes(this.attributeNames);
            super.addAttributesTo(anAttributeManager);
        }
    }

    protected void configureAttributes(AttributeManager anAttributeManager) {
        if (ProductCatalogCharacteristicValueValueImpl.settableAttributeNames != null) {
            anAttributeManager.setSettableAttributes(ProductCatalogCharacteristicValueValueImpl.settableAttributeNames);
            super.configureAttributes(anAttributeManager);
        }
    }

    /**
     * Holds the Attribute manager that manage the optional fields
    */
    private static AttributeManager attributemanager = null;

    protected AttributeManager getAttributeManager() {
        return attributemanager;
    }
    protected AttributeManager makeAttributeManager() {
        attributemanager = new AttributeManager();
        return attributemanager;
    }

    public String[] attributeTypeForValidFor() {
        return attributeTypeFor("validFor");
    }

    
    //==================================================================
    // FACTORIES AND ATTRIBUTE TYPE FOR ================================
    //==================================================================
    
    public javax.oss.cbe.datatypes.TimePeriod makeTimePeriod(String type){
        if(type.equals("javax.oss.cbe.datatypes.TimePeriod") || type.equals("ossj.common.cbe.datatypes.TimePeriodImpl")) {
            return new TimePeriodImpl();
        } else {
            return null;
        }
    }

    public javax.oss.cbe.product.productoffering.ProductCatalogCharacteristicValueKey makeProductCatalogCharacteristicValueKey(){
        return (ProductCatalogCharacteristicValueKey) makeManagedEntityKey();
    }

    /**
     * Init the Map Attribute Name/Attribute Type
     * Init the enumeration Map
     */
    protected void initAttributeTypes(){
        String[] list = new String[1];
        list[0] = "java.lang.String";
        addAttributeTypes("valueFrom", list);
        list[0] = "javax.oss.cbe.datatypes.TimePeriod";
        addAttributeTypes("validFor", list);
        list[0] = "java.lang.String";
        addAttributeTypes("value", list);
        list[0] = "java.lang.String";
        addAttributeTypes("valueTo", list);
        list[0] = "java.lang.String";
        addAttributeTypes("type", list);
    }

    private java.lang.String _productcatalogcharacteristicvaluevalueimpl_type = null;
    private javax.oss.cbe.datatypes.TimePeriod _productcatalogcharacteristicvaluevalueimpl_validFor = null;
    private java.lang.String _productcatalogcharacteristicvaluevalueimpl_value = null;
    private java.lang.String _productcatalogcharacteristicvaluevalueimpl_valueFrom = null;
    private java.lang.String _productcatalogcharacteristicvaluevalueimpl_valueTo = null;


    /**
     * Changes the productCatalogCharacteristicValueKey to be equal to the given argument.
     * 
     * This method support a null argument.
     * 
     * @param value the new productCatalogCharacteristicValueKey for this object.
     * @exception java.lang.IllegalArgumentException - Is thrown to report
     * that a bad argument was provided to the method.
    */

    public void setProductCatalogCharacteristicValueKey(javax.oss.cbe.product.productoffering.ProductCatalogCharacteristicValueKey value)
    throws java.lang.IllegalArgumentException    {
        setEntityKey(value);
    }


    /**
     * Returns this ProductCatalogCharacteristicValueValueImpl's productCatalogCharacteristicValueKey
     * 
     * @return the productCatalogCharacteristicValueKey
     * 
    */

    public javax.oss.cbe.product.productoffering.ProductCatalogCharacteristicValueKey getProductCatalogCharacteristicValueKey()
    throws java.lang.IllegalStateException {
        return (javax.oss.cbe.product.productoffering.ProductCatalogCharacteristicValueKey)getEntityKey();
    }

    /**
     * Changes the type to be equal to the given argument.
     * 
     * This method support a null argument.
     * 
     * @param value the new type for this object.
     * @exception java.lang.IllegalArgumentException - Is thrown to report
     * that a bad argument was provided to the method.
    */

    public void setType(java.lang.String value)
    throws java.lang.IllegalArgumentException    {
        setDirtyAttribute(ProductCatalogCharacteristicValueValue.TYPE);
        _productcatalogcharacteristicvaluevalueimpl_type = value;
    }


    /**
     * Returns this ProductCatalogCharacteristicValueValueImpl's type
     * 
     * @return the type
     * 
    */

    public java.lang.String getType()
    throws java.lang.IllegalStateException {
        checkAttribute(ProductCatalogCharacteristicValueValue.TYPE);
        return _productcatalogcharacteristicvaluevalueimpl_type;
    }

    /**
     * Changes the validFor to be equal to the given argument.
     * 
     * This method support a null argument.
     * 
     * @param value the new validFor for this object.
     * @exception java.lang.IllegalArgumentException - Is thrown to report
     * that a bad argument was provided to the method.
    */

    public void setValidFor(javax.oss.cbe.datatypes.TimePeriod value)
    throws java.lang.IllegalArgumentException    {
        setDirtyAttribute(ProductCatalogCharacteristicValueValue.VALID_FOR);
        _productcatalogcharacteristicvaluevalueimpl_validFor = value;
    }


    /**
     * Returns this ProductCatalogCharacteristicValueValueImpl's validFor
     * 
     * @return the validFor
     * 
    */

    public javax.oss.cbe.datatypes.TimePeriod getValidFor()
    throws java.lang.IllegalStateException {
        checkAttribute(ProductCatalogCharacteristicValueValue.VALID_FOR);
        return _productcatalogcharacteristicvaluevalueimpl_validFor;
    }

    /**
     * Changes the value to be equal to the given argument.
     * 
     * This method support a null argument.
     * 
     * @param value the new value for this object.
     * @exception java.lang.IllegalArgumentException - Is thrown to report
     * that a bad argument was provided to the method.
    */

    public void setValue(java.lang.String value)
    throws java.lang.IllegalArgumentException    {
        setDirtyAttribute(ProductCatalogCharacteristicValueValue.VALUE);
        _productcatalogcharacteristicvaluevalueimpl_value = value;
    }


    /**
     * Returns this ProductCatalogCharacteristicValueValueImpl's value
     * 
     * @return the value
     * 
    */

    public java.lang.String getValue()
    throws java.lang.IllegalStateException {
        checkAttribute(ProductCatalogCharacteristicValueValue.VALUE);
        return _productcatalogcharacteristicvaluevalueimpl_value;
    }

    /**
     * Changes the valueFrom to be equal to the given argument.
     * 
     * This method support a null argument.
     * 
     * @param value the new valueFrom for this object.
     * @exception java.lang.IllegalArgumentException - Is thrown to report
     * that a bad argument was provided to the method.
    */

    public void setValueFrom(java.lang.String value)
    throws java.lang.IllegalArgumentException    {
        setDirtyAttribute(ProductCatalogCharacteristicValueValue.VALUE_FROM);
        _productcatalogcharacteristicvaluevalueimpl_valueFrom = value;
    }


    /**
     * Returns this ProductCatalogCharacteristicValueValueImpl's valueFrom
     * 
     * @return the valueFrom
     * 
    */

    public java.lang.String getValueFrom()
    throws java.lang.IllegalStateException {
        checkAttribute(ProductCatalogCharacteristicValueValue.VALUE_FROM);
        return _productcatalogcharacteristicvaluevalueimpl_valueFrom;
    }

    /**
     * Changes the valueTo to be equal to the given argument.
     * 
     * This method support a null argument.
     * 
     * @param value the new valueTo for this object.
     * @exception java.lang.IllegalArgumentException - Is thrown to report
     * that a bad argument was provided to the method.
    */

    public void setValueTo(java.lang.String value)
    throws java.lang.IllegalArgumentException    {
        setDirtyAttribute(ProductCatalogCharacteristicValueValue.VALUE_TO);
        _productcatalogcharacteristicvaluevalueimpl_valueTo = value;
    }


    /**
     * Returns this ProductCatalogCharacteristicValueValueImpl's valueTo
     * 
     * @return the valueTo
     * 
    */

    public java.lang.String getValueTo()
    throws java.lang.IllegalStateException {
        checkAttribute(ProductCatalogCharacteristicValueValue.VALUE_TO);
        return _productcatalogcharacteristicvaluevalueimpl_valueTo;
    }

    /**
     * Creates a new object of the same class and with the same contents as this object.
     * @return a clone of this instance.
    */
    public Object clone() {
        ProductCatalogCharacteristicValueValue val = null;
            val = (ProductCatalogCharacteristicValueValue)super.clone();

            if( isPopulated(ProductCatalogCharacteristicValueValue.TYPE)) {
                if( this.getType()!=null) 
                    val.setType(((java.lang.String) new String( this.getType())));
                else
                    val.setType( null );
            }

            if( isPopulated(ProductCatalogCharacteristicValueValue.VALID_FOR)) {
                if( this.getValidFor()!=null) 
                    val.setValidFor((javax.oss.cbe.datatypes.TimePeriod)((javax.oss.cbe.datatypes.TimePeriod) this.getValidFor()).clone());
                else
                    val.setValidFor( null );
            }

            if( isPopulated(ProductCatalogCharacteristicValueValue.VALUE)) {
                if( this.getValue()!=null) 
                    val.setValue(((java.lang.String) new String( this.getValue())));
                else
                    val.setValue( null );
            }

            if( isPopulated(ProductCatalogCharacteristicValueValue.VALUE_FROM)) {
                if( this.getValueFrom()!=null) 
                    val.setValueFrom(((java.lang.String) new String( this.getValueFrom())));
                else
                    val.setValueFrom( null );
            }

            if( isPopulated(ProductCatalogCharacteristicValueValue.VALUE_TO)) {
                if( this.getValueTo()!=null) 
                    val.setValueTo(((java.lang.String) new String( this.getValueTo())));
                else
                    val.setValueTo( null );
            }

            return val;
    }

    /**
     * Checks whether two ProductCatalogCharacteristicValueValue are equal.
     * The result is true if and only if the argument is not null 
     * and is an ProductCatalogCharacteristicValueValue object that has the arguments.
     * 
     * @param value the Object to compare with this ProductCatalogCharacteristicValueValue
     * @return if the objects are equal; false otherwise.
     */

    public boolean equals (Object value) {
        if ( this == value ){ return true;}
        if ( (value != null) && ( value instanceof ProductCatalogCharacteristicValueValue)) {
            ProductCatalogCharacteristicValueValue argVal = (ProductCatalogCharacteristicValueValue) value;
            return Utils.compareAttributeAccess( this, argVal );
        }
        return false;
    }

}
