/*
Copyright 2002-2006 The Members of the OSS through Java(TM) Initiative.
All rights reserved. Use is subject to license terms.
*/
package ossj.common.cbe.product.productoffering;

import javax.oss.cbe.product.productoffering.ProductCatalogCharacteristicValueValue;
import javax.oss.cbe.product.productoffering.ProductCatalogCharacteristicValueValueIterator;


/**
 * An implementation class for the <CODE>javax.oss.cbe.product.productoffering.ProductCatalogCharacteristicValueValueIterator</CODE> interface.  
 * 
 * @see javax.oss.cbe.product.productoffering.ProductCatalogCharacteristicValueValueIterator
 * 
 * @author OSS through Java(tm) Initiative, Vincent Perrot Sun Microsystems Inc.
 * @version 1.3 
 * @since January 2006 
 */


public class ProductCatalogCharacteristicValueValueIteratorImpl
extends ossj.common.cbe.EntityValueIteratorImpl
implements ProductCatalogCharacteristicValueValueIterator
{ 

    /**
     * Constructs a new ProductCatalogCharacteristicValueValueIteratorImpl with empty attributes.
     * 
     */

    public ProductCatalogCharacteristicValueValueIteratorImpl() {
        super();
    }

    /**
     * Constructs a new ProductCatalogCharacteristicValueValueIteratorImpl and add the given values.
     * @param values, the array of values
     *
     */
    public ProductCatalogCharacteristicValueValueIteratorImpl(ProductCatalogCharacteristicValueValue[] values){
        super(values);
    }

    /** 
     * Returns the next specified number of elements in the iteration. 
     * @param howMany number of element to return
     * @return the array of howMany elements
     * @throws java.rmi.RemoteException
     * @see javax.oss.ManagedEntityValueIterator#getNext(int)
     */
    public ProductCatalogCharacteristicValueValue[] getNextProductCatalogCharacteristicValues(int howMany)
    throws java.rmi.RemoteException {
        return (ProductCatalogCharacteristicValueValue[]) getNext(howMany);
    }




}
