/*
Copyright 2002-2006 The Members of the OSS through Java(TM) Initiative.
All rights reserved. Use is subject to license terms.
*/
package ossj.common.cbe.product.productoffering;

import javax.oss.cbe.product.productoffering.ProductCatalogSpecificationKey;
import javax.oss.cbe.datatypes.TimePeriod;
import ossj.common.cbe.datatypes.TimePeriodImpl;
import javax.oss.cbe.product.productoffering.ProductCatalogSpecificationValue;
import ossj.common.AttributeManager;
import ossj.common.Utils;


/**
 * An implementation class for the <CODE>javax.oss.cbe.product.productoffering.ProductCatalogSpecificationValue</CODE> interface.  
 * 
 * @see javax.oss.AttributeAccess
 * 
 * @see javax.oss.cbe.product.productoffering.ProductCatalogSpecificationValue
 * 
 * @see javax.oss.ManagedEntityValue
 * 
 * @author OSS through Java(tm) Initiative, Vincent Perrot Sun Microsystems Inc.
 * @version 1.3 
 * @since January 2006 
 */


public class ProductCatalogSpecificationValueImpl
extends ossj.common.cbe.EntitySpecificationValueImpl
implements ProductCatalogSpecificationValue
{ 

    /**
     * Constructs a new ProductCatalogSpecificationValueImpl with empty attributes.
     * 
     */

    public ProductCatalogSpecificationValueImpl() {
        super();
        setManagedEntityKeyInstance( new ProductCatalogSpecificationKeyImpl());
        initAttributeTypes();
    }

    private static final String[] attributeNames = {
        ProductCatalogSpecificationValue.DESCRIPTION,
        ProductCatalogSpecificationValue.NAME,
        ProductCatalogSpecificationValue.VALID_FOR
    };

    private static final String[] settableAttributeNames = {
        ProductCatalogSpecificationValue.DESCRIPTION,
        ProductCatalogSpecificationValue.NAME,
        ProductCatalogSpecificationValue.VALID_FOR
    };

    //
    // Configuration of AttributeManager and AttributeAccess
    //
    protected void addAttributesTo(AttributeManager anAttributeManager) {
        if (ProductCatalogSpecificationValueImpl.attributeNames != null) {
            anAttributeManager.addAttributes(this.attributeNames);
            super.addAttributesTo(anAttributeManager);
        }
    }

    protected void configureAttributes(AttributeManager anAttributeManager) {
        if (ProductCatalogSpecificationValueImpl.settableAttributeNames != null) {
            anAttributeManager.setSettableAttributes(ProductCatalogSpecificationValueImpl.settableAttributeNames);
            super.configureAttributes(anAttributeManager);
        }
    }

    /**
     * Holds the Attribute manager that manage the optional fields
    */
    private static AttributeManager attributemanager = null;

    protected AttributeManager getAttributeManager() {
        return attributemanager;
    }
    protected AttributeManager makeAttributeManager() {
        attributemanager = new AttributeManager();
        return attributemanager;
    }

    public String[] attributeTypeForValidFor() {
        return attributeTypeFor("validFor");
    }

    
    //==================================================================
    // FACTORIES AND ATTRIBUTE TYPE FOR ================================
    //==================================================================
    
    public javax.oss.cbe.datatypes.TimePeriod makeTimePeriod(String type){
        if(type.equals("javax.oss.cbe.datatypes.TimePeriod") || type.equals("ossj.common.cbe.datatypes.TimePeriodImpl")) {
            return new TimePeriodImpl();
        } else {
            return null;
        }
    }

    public javax.oss.cbe.product.productoffering.ProductCatalogSpecificationKey makeProductCatalogSpecificationKey(){
        return (ProductCatalogSpecificationKey) makeManagedEntityKey();
    }

    /**
     * Init the Map Attribute Name/Attribute Type
     * Init the enumeration Map
     */
    protected void initAttributeTypes(){
        String[] list = new String[1];
        list[0] = "javax.oss.cbe.datatypes.TimePeriod";
        addAttributeTypes("validFor", list);
        list[0] = "java.lang.String";
        addAttributeTypes("description", list);
        list[0] = "java.lang.String";
        addAttributeTypes("name", list);
    }

    private java.lang.String _productcatalogspecificationvalueimpl_description = null;
    private java.lang.String _productcatalogspecificationvalueimpl_name = null;
    private javax.oss.cbe.datatypes.TimePeriod _productcatalogspecificationvalueimpl_validFor = null;


    /**
     * Changes the description to be equal to the given argument.
     * 
     * This method support a null argument.
     * 
     * @param value the new description for this object.
     * @exception java.lang.IllegalArgumentException - Is thrown to report
     * that a bad argument was provided to the method.
    */

    public void setDescription(java.lang.String value)
    throws java.lang.IllegalArgumentException    {
        setDirtyAttribute(ProductCatalogSpecificationValue.DESCRIPTION);
        _productcatalogspecificationvalueimpl_description = value;
    }


    /**
     * Returns this ProductCatalogSpecificationValueImpl's description
     * 
     * @return the description
     * 
    */

    public java.lang.String getDescription()
    throws java.lang.IllegalStateException {
        checkAttribute(ProductCatalogSpecificationValue.DESCRIPTION);
        return _productcatalogspecificationvalueimpl_description;
    }

    /**
     * Changes the name to be equal to the given argument.
     * 
     * This method support a null argument.
     * 
     * @param value the new name for this object.
     * @exception java.lang.IllegalArgumentException - Is thrown to report
     * that a bad argument was provided to the method.
    */

    public void setName(java.lang.String value)
    throws java.lang.IllegalArgumentException    {
        setDirtyAttribute(ProductCatalogSpecificationValue.NAME);
        _productcatalogspecificationvalueimpl_name = value;
    }


    /**
     * Returns this ProductCatalogSpecificationValueImpl's name
     * 
     * @return the name
     * 
    */

    public java.lang.String getName()
    throws java.lang.IllegalStateException {
        checkAttribute(ProductCatalogSpecificationValue.NAME);
        return _productcatalogspecificationvalueimpl_name;
    }

    /**
     * Changes the productCatalogSpecificationKey to be equal to the given argument.
     * 
     * This method support a null argument.
     * 
     * @param value the new productCatalogSpecificationKey for this object.
     * @exception java.lang.IllegalArgumentException - Is thrown to report
     * that a bad argument was provided to the method.
    */

    public void setProductCatalogSpecificationKey(javax.oss.cbe.product.productoffering.ProductCatalogSpecificationKey value)
    throws java.lang.IllegalArgumentException    {
        setEntitySpecificationKey(value);
    }


    /**
     * Returns this ProductCatalogSpecificationValueImpl's productCatalogSpecificationKey
     * 
     * @return the productCatalogSpecificationKey
     * 
    */

    public javax.oss.cbe.product.productoffering.ProductCatalogSpecificationKey getProductCatalogSpecificationKey()
    throws java.lang.IllegalStateException {
        return (javax.oss.cbe.product.productoffering.ProductCatalogSpecificationKey)getEntitySpecificationKey();
    }

    /**
     * Changes the validFor to be equal to the given argument.
     * 
     * This method support a null argument.
     * 
     * @param value the new validFor for this object.
     * @exception java.lang.IllegalArgumentException - Is thrown to report
     * that a bad argument was provided to the method.
    */

    public void setValidFor(javax.oss.cbe.datatypes.TimePeriod value)
    throws java.lang.IllegalArgumentException    {
        setDirtyAttribute(ProductCatalogSpecificationValue.VALID_FOR);
        _productcatalogspecificationvalueimpl_validFor = value;
    }


    /**
     * Returns this ProductCatalogSpecificationValueImpl's validFor
     * 
     * @return the validFor
     * 
    */

    public javax.oss.cbe.datatypes.TimePeriod getValidFor()
    throws java.lang.IllegalStateException {
        checkAttribute(ProductCatalogSpecificationValue.VALID_FOR);
        return _productcatalogspecificationvalueimpl_validFor;
    }

    /**
     * Creates a new object of the same class and with the same contents as this object.
     * @return a clone of this instance.
    */
    public Object clone() {
        ProductCatalogSpecificationValue val = null;
            val = (ProductCatalogSpecificationValue)super.clone();

            if( isPopulated(ProductCatalogSpecificationValue.DESCRIPTION)) {
                if( this.getDescription()!=null) 
                    val.setDescription(((java.lang.String) new String( this.getDescription())));
                else
                    val.setDescription( null );
            }

            if( isPopulated(ProductCatalogSpecificationValue.NAME)) {
                if( this.getName()!=null) 
                    val.setName(((java.lang.String) new String( this.getName())));
                else
                    val.setName( null );
            }

            if( isPopulated(ProductCatalogSpecificationValue.VALID_FOR)) {
                if( this.getValidFor()!=null) 
                    val.setValidFor((javax.oss.cbe.datatypes.TimePeriod)((javax.oss.cbe.datatypes.TimePeriod) this.getValidFor()).clone());
                else
                    val.setValidFor( null );
            }

            return val;
    }

    /**
     * Checks whether two ProductCatalogSpecificationValue are equal.
     * The result is true if and only if the argument is not null 
     * and is an ProductCatalogSpecificationValue object that has the arguments.
     * 
     * @param value the Object to compare with this ProductCatalogSpecificationValue
     * @return if the objects are equal; false otherwise.
     */

    public boolean equals (Object value) {
        if ( this == value ){ return true;}
        if ( (value != null) && ( value instanceof ProductCatalogSpecificationValue)) {
            ProductCatalogSpecificationValue argVal = (ProductCatalogSpecificationValue) value;
            return Utils.compareAttributeAccess( this, argVal );
        }
        return false;
    }

}
