/*
Copyright 2002-2006 The Members of the OSS through Java(TM) Initiative.
All rights reserved. Use is subject to license terms.
*/
package ossj.common.cbe.product.productoffering;

import javax.oss.cbe.product.productoffering.ProductCatalogSpecificationValue;
import javax.oss.cbe.product.productoffering.ProductCatalogSpecificationValueIterator;


/**
 * An implementation class for the <CODE>javax.oss.cbe.product.productoffering.ProductCatalogSpecificationValueIterator</CODE> interface.  
 * 
 * @see javax.oss.cbe.product.productoffering.ProductCatalogSpecificationValueIterator
 * 
 * @author OSS through Java(tm) Initiative, Vincent Perrot Sun Microsystems Inc.
 * @version 1.3 
 * @since January 2006 
 */


public class ProductCatalogSpecificationValueIteratorImpl
extends ossj.common.cbe.EntitySpecificationValueIteratorImpl
implements ProductCatalogSpecificationValueIterator
{ 

    /**
     * Constructs a new ProductCatalogSpecificationValueIteratorImpl with empty attributes.
     * 
     */

    public ProductCatalogSpecificationValueIteratorImpl() {
        super();
    }

    /**
     * Constructs a new ProductCatalogSpecificationValueIteratorImpl and add the given values.
     * @param values, the array of values
     *
     */
    public ProductCatalogSpecificationValueIteratorImpl(ProductCatalogSpecificationValue[] values){
        super(values);
    }

    /** 
     * Returns the next specified number of elements in the iteration. 
     * @param howMany number of element to return
     * @return the array of howMany elements
     * @throws java.rmi.RemoteException
     * @see javax.oss.ManagedEntityValueIterator#getNext(int)
     */
    public ProductCatalogSpecificationValue[] getNextProductCatalogSpecifications(int howMany)
    throws java.rmi.RemoteException {
        return (ProductCatalogSpecificationValue[]) getNext(howMany);
    }




}
